﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Main application
Public Sub Class_Globals
    ' change to match you app
    Private InitialPage As String = "frmCuteFileBrowser/frmCuteFileBrowser.html"  '<-------- First page to load
    ' other variables needed
    Private AppPage As ABMPage
    Private theme As ABMTheme
    Private ws As WebSocket 'ignore
    Private ABM As ABMaterial 'ignore
    Private Pages As List
    Private PageNeedsUpload As List
    Private ABMPageId As String = ""
End Sub
Public Sub Initialize()
    Pages.Initialize
    PageNeedsUpload.Initialize
    ' add your icons
    ABM.AddAppleTouchIcon("152.png", "152x152")
    ABM.AddMSTileIcon("144.png", "144x144")
    ABM.AddFavorityIcon("32.png", "32x32")
    ABM.AppVersion = ABMShared.AppVersion
    ABM.AppPublishedStartURL = ABMShared.AppPublishedStartURL
    ABM.ThresholdPxConsiderdSmall = 600
    ABM.ThresholdPxConsiderdMedium = 1024
    #If RELEASE
    ABM.PreloadAllJavascriptAndCSSFiles=True	' NEW
    ABM.ActivateGZip("", 1000) ' NEW
    ABM.AppDefaultPageCSSInline=True ' NEW
    ABM.AppDefaultPageJSInline=True ' NEW
    Dim folders As List ' NEW
    folders.Initialize
    folders.Add(File.DirApp & "/www/" & ABMShared.AppName & "/images")
    ABM.ActivatePNGOptimize("", folders, False , 9, False, True )
    #End If
    BuildPage
End Sub
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
    ws = WebSocket1
    ABMPageId = ABM.GetPageID(AppPage, ABMShared.AppName,ws)
    Dim session As HttpSession = ABM.GetSession(ws, ABMShared.SessionMaxInactiveIntervalSeconds) 'ignore
    ' Prepare the page IMPORTANT!
    AppPage.Prepare
    ' NEW 1.09 has to be done on every page
    AppPage.SetAcceptedLanguages(Array As String("en", "fr", "de", "nl"), "en")
    Dim ActiveFoundLanguage As String = AppPage.DetectLanguage(ws.UpgradeRequest.GetHeader("Accept-Language"))
    Log("Users browser language: " & ActiveFoundLanguage)
    ' for the login use the users browser language
    AppPage.SetActiveLanguage(ActiveFoundLanguage, "" )
    ' NEW
    ConnectPage
    ' navigate to the first page
    If ABMShared.NeedsAuthorization Then
        If ws.Session.GetAttribute2("IsAuthorized", "") = "" Then
            Dim loginpwd As String = ABM.LoadLogin(AppPage, ABMShared.AppName)
            'If loginpwd <> "" Then
            '	Dim SQL As SQL = DBM.GetSQL
            '	Dim split() As String = Regex.Split(";", loginpwd)
            '	Dim vars As List
            '	vars.Initialize
            '	vars.Add(split(0))
            '	vars.Add(split(1))
            '	Dim users As List = DBM.SQLSelect(SQL, "SELECT * FROM users WHERE UserLogin=? AND UserPassword=?", vars)
            '	'Dim users As List = DBM.SQLSelect(SQL, "SELECT * FROM users WHERE UserLogin='" & split(0) & "' AND UserPassword='" & split(1) & "'")
            '	If users.Size > 0 Then
            '		Dim user As Map = users.Get(0)
            '		ws.Session.SetAttribute("authType", "local")
            '		ws.Session.SetAttribute("authName", split(0))
            '		ws.Session.SetAttribute("IsAuthorized", "true")
            '		ws.Session.SetAttribute("UserType", "" & user.Get("usertype") )	' lowercase!
            '		ws.Session.SetAttribute("UserID", "" & user.Get("userid") ) ' lowercase!
            '		ABMShared.NavigateToPage(ws, ABMPageId, "./" & InitialPage)
            '		DBM.CloseSQL(SQL)
            '		Return
            '	End If
            '	DBM.CloseSQL(SQL)
            'End If
            AppPage.ShowModalSheet("login")
            Return
        End If
    End If
    ' NEW 1.09
    ' but you can of course overrule this (e.g. because the user can choose)
    AppPage.SetActiveLanguage("en", "")
    ABMShared.NavigateToPage(ws, ABMPageId, "./" & InitialPage)
End Sub
Private Sub WebSocket_Disconnected()
    Log("Disconnected")
End Sub
Public Sub Page_ParseEvent(Params As Map)
    Dim eventName As String = Params.Get("eventname")
    Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
    If eventName = "beforeunload" Then
        Log("preparing for url refresh")
        ABM.RemoveMeFromCache(ABMShared.CachedPages, ABMPageId)
        Return
    End If
    If SubExists(Me, eventName) Then
        Params.Remove("eventname")
        Params.Remove("eventparams")
        Select Case Params.Size
        Case 0
            CallSub(Me, eventName)
        Case 1
            CallSub2(Me, eventName, Params.Get(eventParams(0)))
        Case 2
            If Params.get(eventParams(0)) = "abmistable" Then
                Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
                CallSub2(Me, eventName, PassedTables)
            Else
                CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
            End If
        Case Else
            ' cannot be called directly, to many param
            CallSub2(Me, eventName, Params)
        End Select
    End If
End Sub
public Sub AddPage(page As ABMPage)
    Pages.Add(page.Name)
    PageNeedsUpload.Add(ABM.WritePageToDisk(page, File.DirApp & "/www/" & ABMShared.AppName & "/" & page.Name & "/", page.PageHTMLName, ABMShared.NeedsAuthorization))
End Sub
public Sub StartServer(srvr As Server, srvrName As String, srvrPort As Int)
    ABM.WriteAppLauchPageToDisk(AppPage, File.DirApp & "/www/" & ABMShared.AppName, "index.html", ABMShared.NeedsAuthorization)
    ' start the server
    srvr.Initialize(srvrName)
    srvr.AddFilter("/js/b4j_ws.min.js", "ABMSessionCreator", False)
    srvr.AddWebSocket("/ws/" & ABMShared.AppName, "ABMApplication")
    For i =0 To Pages.Size - 1
        srvr.AddWebSocket("/ws/" & ABMShared.AppName & "/" & Pages.Get(i) , Pages.Get(i))
        If PageNeedsUpload.Get(i) Then
            srvr.AddHandler("/" & ABMShared.AppName & "/" & Pages.Get(i) & "/abmuploadhandler", "ABMUploadHandler", False)
        End If
    Next
    srvr.AddBackgroundWorker("ABMCacheScavenger")
    srvr.Port = srvrPort
    #If RELEASE
    srvr.SetStaticFilesOptions(CreateMap("cacheControl": "max-age=604800,public","gzip":True,"dirAllowed":False))
    #Else
    srvr.SetStaticFilesOptions(CreateMap("cacheControl": "max-age=604800,public","gzip":False,"dirAllowed":False))
    #End If
    srvr.Start
    Dim jo As JavaObject = srvr
    Dim connectors() As Object = jo.GetFieldJO("server").RunMethod("getConnectors", Null)
    Dim timeout As Long = ABMShared.SessionMaxInactiveIntervalSeconds*1000
    For Each c As JavaObject In connectors
        c.RunMethod("setIdleTimeout", Array(timeout))
    Next
    ABMShared.CachedPages = srvr.CreateThreadSafeMap
End Sub
public Sub StartServerHTTP2(srvr As Server, srvrName As String, srvrPort As Int, SSLsvrPort As Int,  SSLKeyStoreFileName As String, SSLKeyStorePassword As String, SSLKeyManagerPassword As String)
    ABM.WriteAppLauchPageToDisk(AppPage, File.DirApp & "/www/" & ABMShared.AppName, "index.html", ABMShared.NeedsAuthorization)
    Dim ssl As SslConfiguration
    ssl.Initialize
    ssl.SetKeyStorePath(File.DirApp, SSLKeyStoreFileName) 'path to keystore file
    ssl.KeyStorePassword = SSLKeyStorePassword
    ssl.KeyManagerPassword = SSLKeyManagerPassword
    srvr.SetSslConfiguration(ssl, SSLsvrPort)
    ' start the server
    srvr.Initialize(srvrName)
    srvr.AddFilter("/js/b4j_ws.min.js", "ABMSessionCreator", False)
    srvr.AddWebSocket("/ws/" & ABMShared.AppName, "ABMApplication")
    For i =0 To Pages.Size - 1
        srvr.AddWebSocket("/ws/" & ABMShared.AppName & "/" & Pages.Get(i) , Pages.Get(i))
        If PageNeedsUpload.Get(i) Then
            srvr.AddHandler("/" & ABMShared.AppName & "/" & Pages.Get(i) & "/abmuploadhandler", "ABMUploadHandler", False)
        End If
    Next
    srvr.AddBackgroundWorker("ABMCacheScavenger")
    srvr.Port = srvrPort
    srvr.Http2Enabled = True
    #If RELEASE
    srvr.SetStaticFilesOptions(CreateMap("cacheControl": "max-age=604800,public","gzip":True,"dirAllowed":False))
    #Else
    srvr.SetStaticFilesOptions(CreateMap("cacheControl": "max-age=604800,public","gzip":False,"dirAllowed":False))
    #End If
    srvr.Start
    Dim jo As JavaObject = srvr
    Dim connectors() As Object = jo.GetFieldJO("server").RunMethod("getConnectors", Null)
    Dim timeout As Long = ABMShared.SessionMaxInactiveIntervalSeconds*1000
    For Each c As JavaObject In connectors
        c.RunMethod("setIdleTimeout", Array(timeout))
    Next
    ABMShared.CachedPages = srvr.CreateThreadSafeMap
End Sub
public Sub BuildTheme()
    theme.Initialize("pagetheme")
    theme.AddABMTheme(ABMShared.MyTheme)
    ' add additional themes specific for this page
End Sub
public Sub BuildPage()
    ' initialize the theme
    BuildTheme
    ' build the local structure IMPORTANT!
    ' initialize this page using our theme
    AppPage.InitializeWithTheme(ABMShared.AppName, "/ws/" & ABMShared.AppName, False, ABMShared.SessionMaxInactiveIntervalSeconds, theme)
    AppPage.ShowLoader=False
    AppPage.ShowLoaderType=ABM.LOADER_TYPE_MANUAL ' NEW
    AppPage.PageTitle = "DRPW"
    AppPage.PageDescription = ""
    AppPage.PageHTMLName = "index.html"
    AppPage.PageKeywords = ""
    AppPage.PageSiteMapPriority = "0.50"
    AppPage.PageSiteMapFrequency = ABM.SITEMAP_FREQ_MONTHLY
    AppPage.UseGoogleAnalytics(ABMShared.TrackingID, Null) ' IMPORTANT Change this to your own TrackingID !!!!!!!
    ' adding a navigation bar
    ' create the page grid
    AppPage.AddRows(1,True, "").AddCells12(1,"")
    AppPage.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
End Sub
Public Sub ConnectPage()
    'add components for the page
    AppPage.Refresh ' IMPORTANT
    ' NEW, because we use ShowLoaderType=ABM.LOADER_TYPE_MANUAL
    AppPage.FinishedLoading 'IMPORTANT
    AppPage.RestoreNavigationBarPosition
End Sub
' clicked on the navigation bar
Public Sub Page_NavigationbarClicked(Action As String, Value As String)
    AppPage.SaveNavigationBarPosition
End Sub
Public Sub Page_FileUploaded(FileName As String, success As Boolean)
End Sub
Public Sub Page_ToastClicked(ToastId As String, Action As String)
End Sub
Public Sub Page_ToastDismissed(ToastId As String)
End Sub
'Sub Page_Authenticated(Params As Map)
'	Log("Authenticated " & Params.Get("name"))
'
'	ws.Session.SetAttribute("authType", Params.Get("network"))
'	ws.Session.SetAttribute("authName", Params.Get("name"))
'	ws.Session.SetAttribute("IsAuthorized", "true")
'	ABMShared.NavigateToPage(ws, "./" & InitialPage)
'End Sub
