﻿Type=StaticCode
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Public Sub Process_Globals
    Public MyTheme As ABMTheme
    Private ABM As ABMaterial 'ignore
    Public NeedsAuthorization As Boolean = False
    Public AppVersion As String = DateTime.Now
    Public AppPublishedStartURL As String = ""
    Public TrackingID As String
    Public PhpPath As String = ""
    Public GoogleMapsAPIExtras As String = ""
    Public AppName As String = "DRPW"
    Private pool As ConnectionPool
    Private SQLite As SQL
    Private DatabaseType As Int
    Public DBOK As Int = 0
    Public DBERROR As Int = -1
    Public DBNORESULTS As Int = -2
    Private UsePool As Boolean
    Public CachedPages As Map
    Public CacheScavengePeriodSeconds As Int = 15*60 ' 15 minutes ' 10 minutes
    Public SessionMaxInactiveIntervalSeconds As Int = 30*60 ' 30 minutes '1*60*24 ' one hour ' -1 = immortal but beware! This means the cache is NEVER emptied!
End Sub
public Sub GetIntensity(sIntensity As String) As String
    Select Case sIntensity
    Case "ABM.INTENSITY_NORMAL"
        Return ABM.INTENSITY_NORMAL
    Case "ABM.INTENSITY_LIGHTEN5"
        Return ABM.INTENSITY_LIGHTEN5
    Case "ABM.INTENSITY_LIGHTEN4"
        Return ABM.INTENSITY_LIGHTEN4
    Case "ABM.INTENSITY_LIGHTEN3"
        Return ABM.INTENSITY_LIGHTEN3
    Case "ABM.INTENSITY_LIGHTEN2"
        Return ABM.INTENSITY_LIGHTEN2
    Case "ABM.INTENSITY_LIGHTEN1"
        Return ABM.INTENSITY_LIGHTEN1
    Case "ABM.INTENSITY_DARKEN1"
        Return ABM.INTENSITY_DARKEN1
    Case "ABM.INTENSITY_DARKEN2"
        Return ABM.INTENSITY_DARKEN2
    Case "ABM.INTENSITY_DARKEN3"
        Return ABM.INTENSITY_DARKEN3
    Case "ABM.INTENSITY_DARKEN4"
        Return ABM.INTENSITY_DARKEN4
    Case "ABM.INTENSITY_ACCENT1"
        Return ABM.INTENSITY_ACCENT1
    Case "ABM.INTENSITY_ACCENT2"
        Return ABM.INTENSITY_ACCENT2
    Case "ABM.INTENSITY_ACCENT3"
        Return ABM.INTENSITY_ACCENT3
    Case "ABM.INTENSITY_ACCENT4"
        Return ABM.INTENSITY_ACCENT4
    Case Else
        Return ABM.INTENSITY_NORMAL
    End Select
End Sub
public Sub GetColor(sColor As String) As String
    Select Case sColor
    Case "ABM.COLOR_AMBER"
        Return ABM.COLOR_AMBER
    Case "ABM.COLOR_BLACK"
        Return ABM.COLOR_BLACK
    Case "ABM.COLOR_BLUE"
        Return ABM.COLOR_BLUE
    Case "ABM.COLOR_BLUEGREY"
        Return ABM.COLOR_BLUEGREY
    Case "ABM.COLOR_BROWN"
        Return ABM.COLOR_BROWN
    Case "ABM.COLOR_CYAN"
        Return ABM.COLOR_CYAN
    Case "ABM.COLOR_DEEPORANGE"
        Return ABM.COLOR_DEEPORANGE
    Case "ABM.COLOR_DEEPPURPLE"
        Return ABM.COLOR_DEEPPURPLE
    Case "ABM.COLOR_GREEN"
        Return ABM.COLOR_GREEN
    Case "ABM.COLOR_GREY"
        Return ABM.COLOR_GREY
    Case "ABM.COLOR_INDIGO"
        Return ABM.COLOR_INDIGO
    Case "ABM.COLOR_LIGHTBLUE"
        Return ABM.COLOR_LIGHTBLUE
    Case "ABM.COLOR_LIGHTGREEN"
        Return ABM.COLOR_LIGHTGREEN
    Case "ABM.COLOR_LIME"
        Return ABM.COLOR_LIME
    Case "ABM.COLOR_ORANGE"
        Return ABM.COLOR_ORANGE
    Case "ABM.COLOR_PINK"
        Return ABM.COLOR_PINK
    Case "ABM.COLOR_PURPLE"
        Return ABM.COLOR_PURPLE
    Case "ABM.COLOR_RED"
        Return ABM.COLOR_RED
    Case "ABM.COLOR_TEAL"
        Return ABM.COLOR_TEAL
    Case "ABM.COLOR_TRANSPARENT"
        Return ABM.COLOR_TRANSPARENT
    Case "ABM.COLOR_WHITE"
        Return ABM.COLOR_WHITE
    Case "ABM.COLOR_YELLOW"
        Return ABM.COLOR_YELLOW
    Case Else
        Return ABM.COLOR_LIGHTBLUE
    End Select
End Sub
Public Sub InStr(Text As String, sFind As String) As Int
    Return Text.IndexOf(sFind)
End Sub
Public Sub Val(value As String) As String
    value = value.Trim
    Dim sout As String = ""
    Dim mout As String = ""
    Dim slen As Int = value.Length
    Dim i As Int = 0
    For i = 0 To slen - 1
        mout = value.CharAt(i)
        If InStr("0123456789.-", mout) <> -1 Then
            sout = sout & mout
        End If
    Next
    Return sout + 0
End Sub
Public Sub FixImage(sPath As String, sExtension As String) As String
    sPath = sPath.replace("[","")
    sPath = sPath.replace("]","")
    sPath = sPath.replace(",","")
    sPath = sPath.replace("-","")
    sPath = sPath.replace(" ","")
    sPath = sPath.trim
    sPath = sPath & sExtension
    Return sPath.ToLowerCase
End Sub
Public Sub FixDelimiter(sValue As String) As String
    If sValue = "|" Then sValue = "\|"
    If sValue = "." Then sValue = "\."
    If sValue = "\" Then sValue = "\\"
    If sValue = "^" Then sValue = "\^"
    If sValue = "$" Then sValue = "\$"
    If sValue = "?" Then sValue = "\?"
    If sValue = "*" Then sValue = "\*"
    If sValue = "+" Then sValue = "\+"
    If sValue = "(" Then sValue = "\("
    If sValue = ")" Then sValue = "\)"
    If sValue = "[" Then sValue = "\["
    If sValue = "{" Then sValue = "\{"
    If sValue = ";" Then sValue = "\;"
    Return sValue
End Sub
Public Sub UpDownSame(variance As String) As String
    If variance < 0 Then Return "../images/up.png"
    If variance > 0 Then Return "../images/down.png"
    If variance = 0 Then Return "../images/same.png"
    Return ""
End Sub
Public Sub MvField(sValue As String, iPosition As Int, Delimiter As String) As String
    If sValue.Length = 0 Then Return ""
    Dim xPos As Int: xPos = sValue.IndexOf(Delimiter)
    If xPos = -1 Then Return sValue
    Dim mValues() As String
    Dim tValues As Int
    Delimiter = FixDelimiter(Delimiter)
    If sValue.EndsWith(Delimiter) Then sValue = sValue & " "
    mValues = Regex.split(Delimiter, sValue)
    tValues = mValues.Length -1
    Select Case iPosition
    Case -1
        Return mValues(tValues)
    Case -2
        Return mValues(tValues - 1)
    Case Else
        iPosition = iPosition - 1
        If iPosition <= -1 Then Return mValues(tValues)
        If iPosition > tValues Then Return ""
        Return mValues(iPosition)
    End Select
End Sub
Public Sub RenameFolder(OldName As String, NewName As String)
    Dim jo1, jo2 As JavaObject
    jo1.InitializeNewInstance("java.io.File", Array(OldName))
    jo2.InitializeNewInstance("java.io.File", Array(NewName))
    Return jo1.RunMethod("renameTo", Array(jo2))
End Sub
Public Sub DeleteFolder(Folder As String)
    Try
        For Each f As String In File.ListFiles(Folder)
            If File.Exists(Folder,f) = True Then File.Delete(Folder, f)
        Next
        File.Delete("",Folder)
    Catch
    End Try
End Sub
Public Sub DeleteFolderRecursive(Folder As String)
    Dim parentFolder As String = File.GetFileParent(Folder)
    Try
        For Each f As String In File.ListFiles(Folder)
            If f <> parentFolder Then
                If File.IsDirectory(Folder, f) Then
                    DeleteFolderRecursive (File.Combine(Folder, f))
                End If
                If File.Exists(Folder,f) = True Then File.Delete(Folder, f)
            End If
        Next
    Catch
    End Try
End Sub
Public Sub YesNo2ZeroOne(value As String) As String
    If value = "N" Or value = "" Then
        Return "0"
    Else
        Return "1"
    End If
End Sub
Public Sub ZeroOne2YN(value As String) As String
    If value = "0" Or value = "" Then
        Return "N"
    Else
        Return "Y"
    End If
End Sub
Public Sub Replace(Text As String, sFind As String, sReplaceWith As String) As String
    Return Text.Replace(sFind, sReplaceWith)
End Sub
Public Sub LongDate(sDate As String) As String
    If sDate.Length = 0 Then Return ""
    Try
        DateTime.DateFormat = "yyyy-MM-dd"
        Dim dt As Long = DateTime.DateParse(sDate)
        DateTime.DateFormat = "EEEE, dd MMMM yyyy"
        Return DateTime.Date(dt)
    Catch
        Return ""
    End Try
End Sub
Public Sub LongDateTime(sDate As String) As String
    If sDate.Length = 0 Then Return ""
    Try
        DateTime.DateFormat = "yyyy-MM-dd HH:mm"
        Dim dt As Long = DateTime.DateParse(sDate)
        DateTime.DateFormat = "EEEE, dd MMMM yyyy HH:mm"
        Return DateTime.Date(dt)
    Catch
        Return ""
    End Try
End Sub
Public Sub ListItemBadge(page As ABMPage, id As String, text As String, messages As String, isnew As Boolean, Theme As String) As ABMContainer
    Dim ItemCont As ABMContainer
    ItemCont.Initialize(page, id, "")
    ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,10,10,10,6,0,0,0,"").AddCellsOSMP(1,0,0,0,2,2,2,6,0,0,0,"")
    ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    Dim lbl As ABMLabel
    lbl.Initialize(page, id & "lbl", text, ABM.SIZE_PARAGRAPH, False, Theme)
    ItemCont.Cell(1,1).AddComponent(lbl)
    Dim badge As ABMBadge
    badge.Initialize(page, id & "badge", messages,  isnew, "")
    ItemCont.Cell(1,2).AddComponent(badge)
    Return ItemCont
End Sub
Public Sub Right(Text As String, Length As Long) As String
    If Length>Text.Length Then Length=Text.Length
    Return Text.SubString(Text.Length-Length)
End Sub
Public Sub Left(Text As String, Length As Long)As String
    If Length>Text.Length Then Length=Text.Length
    Return Text.SubString2(0, Length)
End Sub
Private Sub List2Array (a_lstArgs As List) As String()
    Dim arrArgs(a_lstArgs.Size) As String
    For i = 0 To arrArgs.Length - 1
        arrArgs(i) = a_lstArgs.Get(i)
    Next
    Return arrArgs
End Sub
Public Sub SQLSelectRecordWhereMap(SQL As SQL, TableName As String, WhereFieldEquals As Map) As Map
    Dim lst As Map
    Dim sb As StringBuilder
    sb.Initialize
    sb.Append("SELECT * FROM ").Append(TableName).Append(" WHERE ")
    If WhereFieldEquals.Size = 0 Then
        Log("WhereFieldEquals map empty!")
        Return lst
    End If
    Dim args As List
    args.Initialize
    For i = 0 To WhereFieldEquals.Size - 1
        If i > 0 Then sb.Append(" AND ")
        sb.Append(WhereFieldEquals.GetKeyAt(i)).Append(" ?")
        args.Add(WhereFieldEquals.GetValueAt(i))
    Next
    Return SQLExecuteMap(SQL,sb.ToString, List2Array(args))
End Sub
Public Sub SQLSelectRecordWhereMaps(SQL As SQL, TableName As String, WhereFieldEquals As Map) As List
    Dim lst As List
    lst.Initialize
    Dim sb As StringBuilder
    sb.Initialize
    sb.Append("SELECT * FROM ").Append(TableName).Append(" WHERE ")
    If WhereFieldEquals.Size = 0 Then
        Log("WhereFieldEquals map empty!")
        Return lst
    End If
    Dim args As List
    args.Initialize
    For i = 0 To WhereFieldEquals.Size - 1
        If i > 0 Then sb.Append(" AND ")
        sb.Append(WhereFieldEquals.GetKeyAt(i)).Append(" ?")
        args.Add(WhereFieldEquals.GetValueAt(i))
    Next
    Return SQLExecuteMaps(SQL,sb.ToString,List2Array(args))
End Sub
Public Sub MakeMoney(sValue As String) As String
    If sValue.Length = 0 Then Return "0.00"
    If sValue = "null" Then sValue = "0.00"
    sValue = sValue.Replace(",","")
    sValue = Val(sValue)
    If sValue = "0" Then sValue = "000"
    sValue = Round2(sValue,2)
    Return NumberFormat2(sValue, 1, 2, 2, True)
End Sub
Public Sub Percentage(sValue As String) As String
    If sValue.Length = 0 Then Return "0.00"
    If sValue = "null" Then sValue = "0.00"
    sValue = sValue.Replace(",","")
    sValue = Val(sValue)
    If sValue = "0" Then sValue = "0.00"
    sValue = Round2(sValue,2)
    sValue = sValue & "%"
    Return sValue
End Sub
Public Sub ListItemCard(page As ABMPage, id As String, image As String, title As String, description As String, Theme As String) As ABMCard
    ' image card
    Dim card4 As ABMCard
    card4.InitializeAsCard(page, "card4", title, description, ABM.CARD_NOTSPECIFIED, Theme)
    card4.Image = image
    Return card4
End Sub
Public Sub ListItemIconTitle(page As ABMPage, id As String, icon As String, Title As String, Theme As String) As ABMLabel
    Dim lbl As ABMLabel
    If icon <> "" Then
        lbl.Initialize(page, id, Title, ABM.SIZE_H6, False, Theme)
    Else
        lbl.Initialize(page, id, Title, ABM.SIZE_H6, True, "")
    End If
    lbl.VerticalAlign = True
    lbl.IconName = icon
    Return lbl
End Sub
Public Sub ListItemIconTitleDescription(page As ABMPage, id As String, image As String, Title As String, Subtitle As String, TitleTheme As String, DescriptionTheme As String, bIsCircular As Boolean, ContainerTheme As String) As ABMContainer
    Dim ItemCont As ABMContainer
    ItemCont.Initialize(page, id, ContainerTheme)
    ItemCont.AddRowsM(1,False,6,0, "").AddCellsOSMP(1,0,0,0,3,2,2,0,0,16,0,"").AddCellsOS(1,0,0,0,9,10,10,"")
    ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    Dim SubItemCont As ABMContainer
    SubItemCont.Initialize(page, id & "SubItemCont", ContainerTheme)
    SubItemCont.AddRowsM(1,False, 0,0,"").AddCells12MP(1,-6,0,0,0,"").AddCells12(1,"")
    SubItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    ItemCont.Cell(1,2).AddComponent(SubItemCont)
    Dim lbl1 As ABMLabel
    lbl1.Initialize(page, id & "lbl1", Title, ABM.SIZE_H6, False, TitleTheme)
    lbl1.VerticalAlign = True
    lbl1.IconName = image
    SubItemCont.Cell(1,1).AddComponent(lbl1)
    Dim lbl2 As ABMLabel
    lbl2.Initialize(page, id & "lbl2", Subtitle, ABM.SIZE_H6, False, DescriptionTheme)
    lbl2.VerticalAlign = True
    SubItemCont.Cell(1,2).AddComponent(lbl2)
    Return ItemCont
End Sub
Public Sub ListItemImageTitle(page As ABMPage, id As String, icon As String, Title As String, Theme As String) As ABMLabel
    return ListItemIconTitle(page, id, icon, Title, Theme)
end Sub
Public Sub ListItemTitle(page As ABMPage, id As String, Title As String) As ABMLabel
    Dim lbl As ABMLabel
    lbl.Initialize(page, id, "{NBSP}" & Title, ABM.SIZE_H6, False, "header")
    lbl.VerticalAlign = True
    Return lbl
End Sub
Public Sub ListItemTitleTheme(page As ABMPage, id As String, Title As String, Theme As String) As ABMLabel
    Dim lbl As ABMLabel
    lbl.Initialize(page, id, "{NBSP}" & Title, ABM.SIZE_H6, True, Theme)
    lbl.VerticalAlign = True
    Return lbl
End Sub
Public Sub ListItemImageTitleDescription(page As ABMPage, id As String, image As String, Title As String, Subtitle As String, TitleTheme As String, DescriptionTheme As String, bIsCircular As Boolean, ContainerTheme As String) As ABMContainer
    Dim ItemCont As ABMContainer
    ItemCont.Initialize(page, id, ContainerTheme)
    ItemCont.AddRowsM(1,False,6,0, "").AddCellsOSMP(1,0,0,0,3,2,2,0,0,16,0,"").AddCellsOS(1,0,0,0,9,10,10,"")
    ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    Dim SubItemCont As ABMContainer
    SubItemCont.Initialize(page, id & "SubItemCont", ContainerTheme)
    SubItemCont.AddRowsM(1,False, 0,0,"").AddCells12MP(1,-6,0,0,0,"").AddCells12(1,"")
    SubItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    ItemCont.Cell(1,2).AddComponent(SubItemCont)
    Dim img As ABMImage
    img.Initialize(page, id & "img", image, 1)
    img.SetFixedSize(48,48)
    img.IsCircular = bIsCircular
    img.IsResponsive = True
    ItemCont.Cell(1,1).AddComponent(img)
    Dim lbl1 As ABMLabel
    lbl1.Initialize(page, id & "lbl1", Title, ABM.SIZE_H6, False, TitleTheme)
    lbl1.VerticalAlign = True
    SubItemCont.Cell(1,1).AddComponent(lbl1)
    Dim lbl2 As ABMLabel
    lbl2.Initialize(page, id & "lbl2", Subtitle, ABM.SIZE_H6, False, DescriptionTheme)
    lbl2.VerticalAlign = True
    SubItemCont.Cell(1,2).AddComponent(lbl2)
    Return ItemCont
End Sub
Public Sub SideBarComponent(page As ABMPage, id As String, image As String, Title As String, Subtitle As String, TitleTheme As String, DescriptionTheme As String, bIsCircular As Boolean, ContainerTheme As String) As ABMContainer
    Dim ItemCont As ABMContainer
    ItemCont.Initialize(page, id, ContainerTheme)
    ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,3,3,3,4,0,0,0,"").AddCellsOSMP(1,0,0,0,9,9,9,4,0,0,0,"")
    ItemCont.AddRowsM(1,False,0,0, "").AddCells12(1, "")
    ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    Dim SubItemCont As ABMContainer
    SubItemCont.Initialize(page, id & "SubItemCont", ContainerTheme)
    SubItemCont.AddRowsM(1,False, 0,0,"").AddCells12MP(1,-6,0,0,0,"").AddCells12(1,"")
    SubItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    ItemCont.Cell(1,2).AddComponent(SubItemCont)
    Dim img As ABMImage
    img.Initialize(page, id & "img", image, 1)
    img.SetFixedSize(48,48)
    img.IsCircular = bIsCircular
    img.IsResponsive = True
    ItemCont.Cell(1,1).AddComponent(img)
    Dim lbl1 As ABMLabel
    lbl1.Initialize(page, id & "lbl1", Title, ABM.SIZE_H6, False, TitleTheme)
    lbl1.VerticalAlign = True
    SubItemCont.Cell(1,1).AddComponent(lbl1)
    Dim lbl2 As ABMLabel
    lbl2.Initialize(page, id & "lbl2", Subtitle, ABM.SIZE_H6, False, DescriptionTheme)
    lbl2.VerticalAlign = True
    SubItemCont.Cell(1,2).AddComponent(lbl2)
    Return ItemCont
End Sub
Public Sub SessionStorageSave(page As ABMPage, key As String, value As String)
    page.ws.Session.SetAttribute(key, value)
End Sub
Public Sub SessionStorageRead(page As ABMPage, key As String) As String
    Return page.ws.Session.GetAttribute2(key, "")
End Sub
Public Sub LocalStorageSave(page As ABMPage, key As String, value As String)
    ABM.SaveInLocalStorage(page, key, value)
End Sub
Public Sub LocalStorageDelete(page As ABMPage, key As String)
    ABM.DeleteFromLocalStorage(page, key)
End Sub
Public Sub LocalStorageRead(page As ABMPage, key As String) As String
    Return ABM.LoadFromLocalStorage(page, key)
End Sub
Public Sub GetImageFromServer(page As Object, iLink As String, JobName As String, phpTag As String)
    Dim job As HttpJob
    job.Initialize(JobName, page)
    job.Tag = phpTag
    Log(iLink)
    job.Download(iLink)
End Sub
' convert a json string to a map
Public Sub Json2Map(jsonText As String) As Map
    Dim json As JSONParser
    Dim Map1 As Map
    Map1.Initialize
    If Len(jsonText) > 0 Then
        json.Initialize(jsonText)
        Map1 = json.NextObject
    End If
    Return Map1
End Sub
'convert a map to a json string
Public Sub Map2Json(m As Map) As String
    Dim gen As JSONGenerator
    Dim outJSON As String
    gen.Initialize(m)
    outJSON = gen.ToString
    Return outJSON
End Sub
Public Sub Json2List(jsonTxt As String) As List
    Dim root As List
    root.Initialize
    Try
        Dim parser As JSONParser
        parser.Initialize(jsonTxt)
        root = parser.NextArray
        Return root
    Catch
        Return root
    End Try
End Sub
Public Sub ExecutePHP(page As Object, pQuery As Map, JobName As String, phpFile As String, phpTag As String)
    Dim job As HttpJob
    Dim scommand As String
    Dim json As String
    job.Initialize(JobName, page)
    job.Tag = phpTag
    json = Map2QueryString(pQuery)
    If Len(json) = 0 Then
        scommand = PhpPath & phpFile
    Else
        scommand = PhpPath & phpFile & "?" & json
    End If
    Log(scommand)
    job.Download(scommand)
End Sub
Public Sub Map2QueryString(sm As Map) As String
    ' convert a map to a querystring string
    Dim SU As StringUtils
    Dim iCnt As Int
    Dim iTot As Int
    Dim sb As StringBuilder
    Dim mValue As String
    sb.Initialize
    ' get size of map
    iTot = sm.Size - 1
    iCnt = 0
    For Each mKey As String In sm.Keys
        mValue = sm.Get(mKey)
        mValue = SU.EncodeUrl(mValue, "UTF8")
        mKey = mKey.Trim
        If mKey.EndsWith("=") = False Then mKey = mKey & "="
        sb.Append(mKey).Append(mValue)
        If iCnt < iTot Then sb.Append("&")
        iCnt = iCnt + 1
    Next
    Return sb.ToString
End Sub
Public Sub Speak(page As ABMPage, Text As String)
    Dim sb As StringBuilder
    sb.Initialize
    sb.append("window.speechSynthesis.speak(SpeechSynthesisUtterance('")
    sb.append(Text)
    sb.append("'));")
    page.ws.Eval(sb.ToString, Null)
    page.ws.Flush
End Sub
Public Sub NavigateToPage(ws As WebSocket, PageId As String, TargetUrl As String)
    If AppVersion <> "" Then
        TargetUrl = TargetUrl & "?" & AppVersion
    End If
    ABM.RemoveMeFromCache(CachedPages, PageId)
    If ws.Open Then
        ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))
        ws.Flush
    End If
End Sub
Public Sub RedirectOutput (Dir As String, FileName As String)
    #if RELEASE
    Dim out As OutputStream = File.OpenOutput(Dir, FileName, False) 'Set to True to append the logs
    Dim ps As JavaObject
    ps.InitializeNewInstance("java.io.PrintStream", Array(out, True, "utf8"))
    Dim jo As JavaObject
    jo.InitializeStatic("java.lang.System")
    jo.RunMethod("setOut", Array(ps))
    jo.RunMethod("setErr", Array(ps))
    #end if
End Sub
' build methods for ABM objects
Public Sub BuildTheme(themeName As String)
    MyTheme.Initialize(themeName)
    ' the page theme
    MyTheme.Page.BackColor = ABM.COLOR_TRANSPARENT
    MyTheme.Page.BackColorIntensity = ABM.INTENSITY_NORMAL
    MyTheme.Page.ConnectedIndicatorColor = ABM.COLOR_GREEN
    MyTheme.Page.ConnectedIndicatorColorIntensity = ABM.INTENSITY_NORMAL
    MyTheme.Page.DisconnectedIndicatorColor = ABM.COLOR_RED
    MyTheme.Page.DisconnectedIndicatorColorIntensity = ABM.INTENSITY_NORMAL
    MyTheme.Page.PlaceHolderColor = ABM.COLOR_GREY
    MyTheme.Page.PlaceHolderColorIntensity = ABM.INTENSITY_NORMAL
    ' add any shared themes
    MyTheme.AddButtonTheme("transparent")
    MyTheme.Button("transparent").backcolor = ABM.COLOR_TRANSPARENT
    MyTheme.AddButtonTheme("bigblue")
    MyTheme.AddButtonTheme("greenbutton")
    MyTheme.Button("greenbutton").backcolor = ABM.COLOR_GREEN
    MyTheme.Button("greenbutton").forecolor = ABM.COLOR_GREEN
    MyTheme.AddButtonTheme("yellowbutton")
    MyTheme.Button("yellowbutton").backcolor = ABM.COLOR_YELLOW
    MyTheme.Button("yellowbutton").forecolor = ABM.COLOR_YELLOW
    MyTheme.AddButtonTheme("redbutton")
    MyTheme.Button("redbutton").backcolor = ABM.COLOR_RED
    MyTheme.Button("redbutton").forecolor = ABM.COLOR_RED
    MyTheme.AddButtonTheme("tealbutton")
    MyTheme.Button("tealbutton").backcolor = ABM.COLOR_TEAL
    MyTheme.Button("tealbutton").forecolor = ABM.COLOR_TEAL
    MyTheme.AddButtonTheme("orangebutton")
    MyTheme.Button("orangebutton").backcolor = ABM.COLOR_ORANGE
    MyTheme.Button("orangebutton").forecolor = ABM.COLOR_ORANGE
    MyTheme.AddButtonTheme("limedarkbutton")
    MyTheme.Button("limedarkbutton").backcolor = ABM.COLOR_LIME
    MyTheme.Button("limedarkbutton").forecolor = ABM.COLOR_LIME
    MyTheme.Button("limedarkbutton").backcolorintensity = ABM.INTENSITY_DARKEN1
    MyTheme.AddButtonTheme("brownbutton")
    MyTheme.Button("brownbutton").backcolor = ABM.COLOR_BROWN
    MyTheme.Button("brownbutton").forecolorintensity = ABM.INTENSITY_LIGHTEN2
    MyTheme.Button("brownbutton").forecolor = ABM.COLOR_BROWN
    MyTheme.Button("brownbutton").backcolorintensity = ABM.INTENSITY_LIGHTEN2
    MyTheme.AddButtonTheme("orangeaccent4button")
    MyTheme.Button("orangeaccent4button").backcolor = ABM.COLOR_ORANGE
    MyTheme.Button("orangeaccent4button").forecolorintensity = ABM.INTENSITY_ACCENT4
    MyTheme.Button("orangeaccent4button").forecolor = ABM.COLOR_ORANGE
    MyTheme.Button("orangeaccent4button").backcolorintensity = ABM.INTENSITY_ACCENT4
    MyTheme.AddCellTheme("centercontent")
    MyTheme.Cell("centercontent").align = ABM.CELL_ALIGN_CENTER
    MyTheme.AddContainerTheme("footertheme")
    MyTheme.Container("footertheme").backcolor = ABM.COLOR_LIGHTBLUE
    MyTheme.AddContainerTheme("lightblue")
    MyTheme.Container("lightblue").backcolor = ABM.COLOR_LIGHTBLUE
    MyTheme.Container("lightblue").backcolorintensity = ABM.INTENSITY_DARKEN2
    MyTheme.AddContainerTheme("darkblue")
    MyTheme.Container("darkblue").backcolor = ABM.COLOR_LIGHTBLUE
    MyTheme.Container("darkblue").backcolorintensity = ABM.INTENSITY_DARKEN3
    MyTheme.AddContainerTheme("modalcontent")
    MyTheme.Container("modalcontent").backcolor = ABM.COLOR_WHITE
    MyTheme.AddImageSliderTheme("slidertheme")
    MyTheme.ImageSlider("slidertheme").subtitleforecolorintensity = ABM.INTENSITY_DARKEN2
    MyTheme.ImageSlider("slidertheme").titleforecolor = ABM.COLOR_GREEN
    MyTheme.ImageSlider("slidertheme").titleforecolorintensity = ABM.INTENSITY_DARKEN1
    MyTheme.ImageSlider("slidertheme").activebulletcolor = ABM.COLOR_BLUEGREY
    MyTheme.ImageSlider("slidertheme").subtitleforecolor = ABM.COLOR_GREEN
    MyTheme.ImageSlider("slidertheme").interval = 3000
    MyTheme.AddInputTheme("bold")
    MyTheme.Input("bold").bold = True
    MyTheme.AddLabelTheme("whitefc")
    MyTheme.Label("whitefc").forecolor = ABM.COLOR_WHITE
    MyTheme.Label("whitefc").align = ABM.INPUT_TEXTALIGN_START
    MyTheme.AddLabelTheme("justify")
    MyTheme.Label("justify").align = ABM.TEXTALIGN_JUSTIFY
    MyTheme.AddLabelTheme("lightblue")
    MyTheme.Label("lightblue").forecolor = ABM.COLOR_LIGHTBLUE
    MyTheme.Label("lightblue").forecolorintensity = ABM.INTENSITY_DARKEN2
    MyTheme.AddLabelTheme("white")
    MyTheme.Label("white").forecolor = ABM.COLOR_WHITE
    MyTheme.Label("white").align = ABM.TEXTALIGN_CENTER
    MyTheme.Label("white").iconcolor = ABM.COLOR_WHITE
    MyTheme.AddLabelTheme("red")
    MyTheme.Label("red").forecolor = ABM.COLOR_RED
    MyTheme.Label("red").align = ABM.TEXTALIGN_CENTER
    MyTheme.Label("red").iconcolor = ABM.COLOR_RED
    MyTheme.AddLabelTheme("yellow")
    MyTheme.Label("yellow").forecolor = ABM.COLOR_YELLOW
    MyTheme.Label("yellow").align = ABM.TEXTALIGN_CENTER
    MyTheme.Label("yellow").iconcolor = ABM.COLOR_YELLOW
    MyTheme.AddLabelTheme("green")
    MyTheme.Label("green").forecolor = ABM.COLOR_GREEN
    MyTheme.Label("green").align = ABM.TEXTALIGN_CENTER
    MyTheme.Label("green").iconcolor = ABM.COLOR_GREEN
    MyTheme.AddLabelTheme("rightlabel")
    MyTheme.Label("rightlabel").align = ABM.INPUT_TEXTALIGN_RIGHT
    MyTheme.AddLabelTheme("centerlabel")
    MyTheme.Label("centerlabel").align = ABM.INPUT_TEXTALIGN_CENTER
    MyTheme.AddModalSheetTheme("drpw")
    MyTheme.ModalSheet("drpw").footerbackcolorintensity = ABM.INTENSITY_LIGHTEN2
    MyTheme.ModalSheet("drpw").headerbackcolorintensity = ABM.INTENSITY_LIGHTEN2
    MyTheme.ModalSheet("drpw").headerbackcolor = ABM.COLOR_BROWN
    MyTheme.ModalSheet("drpw").footerbackcolor = ABM.COLOR_BROWN
    MyTheme.AddNavigationBarTheme("whiteblack")
    MyTheme.AddNavigationBarTheme("drpw")
    MyTheme.NavigationBar("drpw").topbarbackcolorintensity = ABM.INTENSITY_LIGHTEN2
    MyTheme.NavigationBar("drpw").topbarbackcolor = ABM.COLOR_BROWN
    MyTheme.AddTableTheme("tblTheme")
    MyTheme.Table("tblTheme").zdepth = ABM.ZDEPTH_1
    MyTheme.AddToastTheme("toast")
    MyTheme.Toast("toast").actionforecolor = ABM.COLOR_ORANGE
    MyTheme.Toast("toast").rounded = True
    MyTheme.AddToastTheme("toastred")
    MyTheme.Toast("toastred").backcolor = ABM.COLOR_RED
    MyTheme.Toast("toastred").actionforecolor = ABM.COLOR_BLACK
    MyTheme.AddToastTheme("toastgreen")
    MyTheme.Toast("toastgreen").backcolor = ABM.COLOR_GREEN
    MyTheme.Toast("toastgreen").actionforecolor = ABM.COLOR_BLACK
    MyTheme.Table("tblTheme").AddCellTheme("bg")
    MyTheme.Table("tblTheme").Cell("bg").forecolor = ABM.COLOR_WHITE
    MyTheme.Table("tblTheme").Cell("bg").backcolor = ABM.COLOR_BLUEGREY
    MyTheme.Table("tblTheme").AddCellTheme("bgr")
    MyTheme.Table("tblTheme").Cell("bgr").forecolor = ABM.COLOR_WHITE
    MyTheme.Table("tblTheme").Cell("bgr").align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
    MyTheme.Table("tblTheme").Cell("bgr").backcolor = ABM.COLOR_BLUEGREY
    MyTheme.Table("tblTheme").AddCellTheme("openedit")
    MyTheme.Table("tblTheme").Cell("openedit").activebackcolor = ABM.COLOR_BLUEGREY
    MyTheme.Table("tblTheme").Cell("openedit").align = ABM.TABLECELL_HORIZONTALALIGN_CENTER
    MyTheme.Table("tblTheme").Cell("openedit").activebackcolorintensity = ABM.INTENSITY_LIGHTEN2
    MyTheme.Table("tblTheme").AddCellTheme("bgc")
    MyTheme.Table("tblTheme").Cell("bgc").forecolor = ABM.COLOR_WHITE
    MyTheme.Table("tblTheme").Cell("bgc").align = ABM.TABLECELL_HORIZONTALALIGN_CENTER
    MyTheme.Table("tblTheme").Cell("bgc").backcolor = ABM.COLOR_BLUEGREY
    MyTheme.Table("tblTheme").AddCellTheme("nocolor")
    MyTheme.Table("tblTheme").Cell("nocolor").activebackcolor = ABM.COLOR_BLUEGREY
    MyTheme.Table("tblTheme").Cell("nocolor").activebackcolorintensity = ABM.INTENSITY_LIGHTEN2
    MyTheme.Table("tblTheme").AddCellTheme("positive")
    MyTheme.Table("tblTheme").Cell("positive").activebackcolor = ABM.COLOR_GREEN
    MyTheme.Table("tblTheme").Cell("positive").backcolor = ABM.COLOR_GREEN
    MyTheme.Table("tblTheme").Cell("positive").backcolorintensity = ABM.INTENSITY_LIGHTEN3
    MyTheme.Table("tblTheme").Cell("positive").activebackcolorintensity = ABM.INTENSITY_LIGHTEN1
    MyTheme.Table("tblTheme").AddCellTheme("orange")
    MyTheme.Table("tblTheme").Cell("orange").activebackcolor = ABM.COLOR_ORANGE
    MyTheme.Table("tblTheme").Cell("orange").backcolor = ABM.COLOR_ORANGE
    MyTheme.Table("tblTheme").Cell("orange").backcolorintensity = ABM.INTENSITY_LIGHTEN3
    MyTheme.Table("tblTheme").Cell("orange").activebackcolorintensity = ABM.INTENSITY_LIGHTEN1
    MyTheme.Table("tblTheme").AddCellTheme("gray")
    MyTheme.Table("tblTheme").Cell("gray").activebackcolor = ABM.COLOR_GREY
    MyTheme.Table("tblTheme").Cell("gray").backcolor = ABM.COLOR_GREY
    MyTheme.Table("tblTheme").Cell("gray").backcolorintensity = ABM.INTENSITY_LIGHTEN3
    MyTheme.Table("tblTheme").Cell("gray").activebackcolorintensity = ABM.INTENSITY_LIGHTEN1
    MyTheme.Table("tblTheme").AddCellTheme("yellow")
    MyTheme.Table("tblTheme").Cell("yellow").activebackcolor = ABM.COLOR_YELLOW
    MyTheme.Table("tblTheme").Cell("yellow").backcolor = ABM.COLOR_YELLOW
    MyTheme.Table("tblTheme").Cell("yellow").backcolorintensity = ABM.INTENSITY_LIGHTEN3
    MyTheme.Table("tblTheme").Cell("yellow").activebackcolorintensity = ABM.INTENSITY_LIGHTEN1
    MyTheme.Table("tblTheme").AddCellTheme("negative")
    MyTheme.Table("tblTheme").Cell("negative").activebackcolor = ABM.COLOR_RED
    MyTheme.Table("tblTheme").Cell("negative").backcolor = ABM.COLOR_RED
    MyTheme.Table("tblTheme").Cell("negative").backcolorintensity = ABM.INTENSITY_LIGHTEN3
    MyTheme.Table("tblTheme").Cell("negative").activebackcolorintensity = ABM.INTENSITY_LIGHTEN1
    MyTheme.Table("tblTheme").AddCellTheme("nocolorr")
    MyTheme.Table("tblTheme").Cell("nocolorr").activebackcolor = ABM.COLOR_BLUEGREY
    MyTheme.Table("tblTheme").Cell("nocolorr").align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
    MyTheme.Table("tblTheme").Cell("nocolorr").activebackcolorintensity = ABM.INTENSITY_LIGHTEN2
    MyTheme.Table("tblTheme").AddCellTheme("nocolorc")
    MyTheme.Table("tblTheme").Cell("nocolorc").activebackcolor = ABM.COLOR_BLUEGREY
    MyTheme.Table("tblTheme").Cell("nocolorc").align = ABM.TABLECELL_HORIZONTALALIGN_CENTER
    MyTheme.Table("tblTheme").Cell("nocolorc").activebackcolorintensity = ABM.INTENSITY_LIGHTEN2
End Sub
Public Sub Len(Text As String) As Int
    Return Text.Length
End Sub
Public Sub LogOff(page As ABMPage)
    Dim Network As String = page.ws.Session.GetAttribute("authType")
    Dim Name As String = page.ws.Session.GetAttribute("authName")
    Select Case Network
    Case "local","network"
        ' do whatever you have to do to log off your user
        page.ws.Session.SetAttribute("UserID", "")
        page.ws.Session.SetAttribute("UserEmail", "")
        page.ws.Session.SetAttribute("authType", "")
        page.ws.Session.SetAttribute("authName", "")
        page.ws.Session.SetAttribute("IsAuthorized", "")
        ABM.DeleteLogin(page, AppName)
        NavigateToPage(page.ws, page.GetPageID, "../")
    Case ABM.SOCIALOAUTH_FACEBOOK
        ' the event SignedOffSocialNetwork will be raised on the page, do the rest there
        page.SignOffSocialNetwork(Network, "", Name)
    End Select
End Sub
Public Sub Date2String(date As Long, withTime As Boolean) As String
    Dim OrigFormat As String=DateTime.DateFormat
    If withTime Then
        DateTime.DateFormat="yyyy-MM-dd'T'HH:mm:ss"
    Else
        DateTime.DateFormat="yyyy-MM-dd"
    End If
    Dim MyDate As String =DateTime.Date(date)
    DateTime.DateFormat=OrigFormat
    Return MyDate
End Sub
Public Sub String2Date(date As String) As Long
    Dim lng As Long
    Dim OrigFormat As String=DateTime.DateFormat
    If date.Length > 10 Then
        DateTime.DateFormat = "yyyy-MM-dd"
        DateTime.DateFormat = "HH:mm:ss"
        Dim d As String = date.SubString2(0,11)
        Dim t As String = date.SubString(12)
        lng = DateTime.DateTimeParse(d,t)
    Else
        DateTime.DateFormat = "yyyy-MM-dd"
        lng = DateTime.Dateparse(date)
    End If
    DateTime.DateFormat=OrigFormat
    Return lng
End Sub
Public Sub Mid(Text As String, Start As Int, Length As Int) As String
    Return Text.SubString2(Start-1,Start+Length-1)
End Sub
Public Sub ReplaceAll(Text As String, Pattern As String, Replacement As String) As String
    Dim jo As JavaObject = Regex.Matcher(Pattern, Text)
    Return jo.RunMethod("replaceAll", Array(Replacement))
End Sub
Public Sub Mid2(Text As String, Start As Int) As String
    Return Text.SubString(Start-1)
End Sub
Public Sub BuildImage(page As ABMPage, id As String, image As String, opacity As Double, Caption As String) As ABMImage
    Dim img As ABMImage
    img.Initialize(page, id, image,opacity)
    img.IsMaterialBoxed = True
    img.IsResponsive = True
    img.Caption = Caption
    Return img
End Sub
public Sub BuildHeader(page As ABMPage, id As String, Text As String) As ABMLabel
    Dim hdr As ABMLabel
    hdr.Initialize(page, id, Text, ABM.SIZE_H5, False, "lightblue")
    Return hdr
End Sub
public Sub BuildSubHeader(page As ABMPage, id As String, Text As String) As ABMLabel
    Dim shdr As ABMLabel
    shdr.Initialize(page, id, Text, ABM.SIZE_H5, False, "")
    Return shdr
End Sub
public Sub BuildParagraph(page As ABMPage, id As String, Text As String) As ABMLabel
    Dim lbl As ABMLabel
    lbl.Initialize(page, id, Text , ABM.SIZE_PARAGRAPH, False, "justify")
    Return lbl
End Sub
public Sub BuildParagraphBQ(page As ABMPage, id As String, Text As String) As ABMLabel
    Dim lbl As ABMLabel
    lbl.Initialize(page, id, Text , ABM.SIZE_PARAGRAPH, False, "")
    lbl.IsBlockQuote = True
    Return lbl
End Sub
public Sub BuildSpan(page As ABMPage, id As String, Text As String) As ABMLabel
    Dim lbl As ABMLabel
    lbl.Initialize(page, id, Text , ABM.SIZE_SPAN, False, "")
    Return lbl
End Sub
public Sub BuildCodeBlock(page As ABMPage, id As String, code As StringBuilder) As ABMCodeLabel
    Dim codelab As ABMCodeLabel
    codelab.Initialize(page, id, code.ToString, "vb")
    Return codelab
End Sub
public Sub BuildCodeBlockFromSmartString(page As ABMPage, id As String, code As String) As ABMCodeLabel
    Dim codelab As ABMCodeLabel
    codelab.Initialize(page, id, code, "vb")
    Return codelab
End Sub
public Sub BuildIconBlock(page As ABMPage, id As String, iconName As String) As ABMContainer
    Dim cont As ABMContainer
    cont.Initialize(page, id, "lightblue")
    cont.AddRows(2,False, "").AddCells12(1,"")
    cont.BuildGrid ' IMPORTANT
    ' to help see how the grids looks like in the log
    ' cont.DebugPrintGrid
    Dim lblicon As ABMLabel
    lblicon.Initialize(page, id & "icon", "", ABM.SIZE_H5, False, "whitefc")
    lblicon.IconName = iconName
    lblicon.IconSize = ABM.ICONSIZE_MEDIUM
    cont.Cell(1,1).AddComponent(lblicon)
    Dim lbliconName As ABMLabel
    lbliconName.Initialize(page, id & "lbl", iconName, ABM.SIZE_SPAN, False, "whitefc")
    cont.Cell(2,1).AddComponent(lbliconName)
    Return cont
End Sub
Public Sub BuildFooter(page As ABMPage, Visibility As String)
    page.Footer.AddRows(1, True, "").AddCellsOS(2,0,0,0,6,6,6, "")
    page.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    page.Footer.UseTheme("footertheme")
    page.Footer.Visibility = Visibility
End Sub
Public Sub ConnectFooter(page As ABMPage, leftContent As String, rightContent As String)
    Dim lbl1 As ABMLabel
    lbl1.Initialize(page, "footlbl1", leftContent,ABM.SIZE_PARAGRAPH, False, "whitefc")
    page.Footer.Cell(1,1).AddComponent(lbl1)
    Dim lbl2 As ABMLabel
    lbl2.Initialize(page, "footlbl2", rightContent,ABM.SIZE_PARAGRAPH, False, "whitefc")
    page.Footer.Cell(1,2).AddComponent(lbl2)
End Sub
Public Sub BuildFooterFixed(page As ABMPage, PaddingBottom As Int, Visibility As String)
    page.isFixedFooter= True
    ' because we have a fixed footer at the bottom, we have to adjust the padding of the body in pixels
    page.PaddingBottom = PaddingBottom
    page.Footer.AddRows(1, True, "").AddCellsOS(2,0,0,0,6,6,6, "")
    page.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    page.Footer.UseTheme("footertheme")
    page.Footer.Visibility = Visibility
End Sub
public Sub BuildParamTable(page As ABMPage, id As String, Headers As List, Names As List, Descriptions As List) As ABMTable
    Dim tbl As ABMTable
    tbl.Initialize(page, id, False, False, False, "Params")
    tbl.IgnoreFormattingCodes = True ' build in to ignore formatting tags
    Dim themes As List
    themes.Initialize2(Array As String("header","header"))
    tbl.SetHeaders(Headers)
    tbl.SetHeaderThemes(themes)
    themes.Initialize2(Array As String("name","description"))
    For i = 0 To Names.Size - 1
        Dim Values As List
        Values.Initialize
        Values.Add( Names.Get(i))
        Values.Add( Descriptions.Get(i))
        tbl.AddRow("uid" & i, Values)
        tbl.SetRowThemes(themes)
    Next
    Return tbl
End Sub
public Sub BuildParamTable2(page As ABMPage, id As String, Headers As List, Names As List, Descriptions As List) As ABMTable
    Dim tbl As ABMTable
    tbl.Initialize(page, id, False, False, False, "Params")
    Dim themes As List
    themes.Initialize2(Array As String("header","header"))
    tbl.SetHeaders(Headers)
    tbl.SetHeaderThemes(themes)
    themes.Initialize2(Array As String("name","description"))
    For i = 0 To Names.Size - 1
        Dim Values As List
        Values.Initialize
        Values.Add( Names.Get(i))
        Values.Add( Descriptions.Get(i))
        tbl.AddRow("uid" & i, Values)
        tbl.SetRowThemes(themes)
    Next
    Return tbl
End Sub
'Define a connection to MySQL server
Public Sub MySQLConnectionString(serverIP As String,  serverPort As String, serverDB As String) As String
    Dim sb As StringBuilder
    sb.Initialize
    sb.Append("jdbc:mysql://").Append(serverIP).Append(":").Append(serverPort).Append("/").Append(serverDB)
    Return sb.tostring
End Sub
'Define a connection string to Microsoft SQL server
Public Sub MSSQLConnectionString(serverIP As String,  serverPort As String, serverDB As String) As String
    Dim sb As StringBuilder
    sb.Initialize
    sb.Append("jdbc:jtds:sqlserver://").Append(serverIP).Append(":").Append(serverPort).Append("/").Append(serverDB)
    Return sb.tostring
End Sub
'Initialize a connection to SQLite database
Public Sub InitializeSQLite(Dir As String, fileName As String, createIfNeeded As Boolean) 'ignore
    SQLite.InitializeSQLite(Dir, fileName, createIfNeeded)
    DatabaseType = 0
End Sub
'Initialize a connection to MySQL server and returns True if successful
Public Sub InitializeMySQL(serverIP As String,  serverPort As String, serverDB As String, login As String, password As String, poolSize As Int) As Boolean
    Log("init mysql")
    DatabaseType = 1
    UsePool = True
    Try
        Dim jdbcUrl As String
        jdbcUrl = MySQLConnectionString(serverIP,serverPort,serverDB)
        pool.Initialize("com.mysql.jdbc.Driver", jdbcUrl, login, password)
        ' change pool size...
        Dim jo As JavaObject = pool
        jo.RunMethod("setMaxPoolSize", Array(poolSize))
        Return True
    Catch
        Log("Last Pool Init Except: "&LastException.Message)
        Return False
    End Try
End Sub
'Initialize a connection to Microsoft SQL server
Public Sub InitializeMSSQL(serverIP As String,  serverPort As String, serverDB As String ,login As String, password As String, poolSize As Int) As Boolean
    DatabaseType = 2
    Try
        Dim jdbcUrl As String
        jdbcUrl = MSSQLConnectionString(serverIP,serverPort,serverDB)
        pool.Initialize("net.sourceforge.jtds.jdbc.Driver", jdbcUrl, login, password)
        ' change pool size...
        Dim jo As JavaObject = pool
        jo.RunMethod("setMaxPoolSize", Array(poolSize))
        Return True
    Catch
        Log("Last Pool Init Except: " & LastException.Message)
        Return False
    End Try
End Sub
'Update a single mapped record and return true if successful
Public Sub SQLRecordUpdate(SQL As SQL, TableName As String, Fields As Map, PrimaryKey As String, PrimaryValue As String) As Boolean
    Dim w As Map
    w.Initialize
    w.Put(PrimaryKey, PrimaryValue)
    Return SQLRecordUpdateWhere(SQL,TableName,Fields,w)
End Sub
'Update a mapped record and return true if successful
Public Sub SQLRecordUpdateWhere(SQL As SQL, TableName As String, Fields As Map, WhereFieldEquals As Map) As Boolean
    If WhereFieldEquals.Size = 0 Then
        Log("WhereFieldEquals map empty!")
        Return False
    End If
    If Fields.Size = 0 Then
        Log("Fields empty")
        Return False
    End If
    Dim sb As StringBuilder
    SQL.BeginTransaction
    Try
        sb.Initialize
        sb.Append("UPDATE ").Append(TableName).Append(" SET ")
        Dim args As List
        args.Initialize
        For i=0 To Fields.Size-1
            If i<>Fields.Size-1 Then
                sb.Append(Fields.GetKeyAt(i)).Append("=?,")
            Else
                sb.Append(Fields.GetKeyAt(i)).Append("=?")
            End If
            args.Add(Fields.GetValueAt(i))
        Next
        sb.Append(" WHERE ")
        For i = 0 To WhereFieldEquals.Size - 1
            If i > 0 Then
                sb.Append(" AND ")
            End If
            sb.Append(WhereFieldEquals.GetKeyAt(i)).Append(" = ?")
            args.Add(WhereFieldEquals.GetValueAt(i))
        Next
        Log("UpdateRecord: " & sb.ToString)
        SQL.ExecNonQuery2(sb.ToString, args)
        SQL.TransactionSuccessful
        Return True
    Catch
        Log("UpdateRecord2 Error: " & LastException)
        SQL.Rollback
        Return False
    End Try
End Sub
'Insert a single map record and return true if successful
Public Sub SQLRecordInsert(SQL As SQL, TableName As String, nRecord As Map) As Int
    Dim nList As List
    nList.Initialize
    nList.Add(nRecord)
    Return SQLRecordInsertMaps(SQL, TableName, nList)
End Sub
'Insert Mapped Records to database and return true if successful
Public Sub SQLRecordInsertMaps(SQL As SQL, TableName As String, ListOfMaps As List) As Int
    Dim res As Int
    Dim sb, columns, values As StringBuilder
    'Small check for a common error where the same map is used in a loop
    If ListOfMaps.Size > 1 And ListOfMaps.Get(0) = ListOfMaps.Get(1) Then
        Log("Same Map found twice in list. Each item in the list should include a different map object.")
        Return DBERROR
    End If
    SQL.BeginTransaction
    Try
        For i1 = 0 To ListOfMaps.Size - 1
            sb.Initialize
            columns.Initialize
            values.Initialize
            Dim listOfValues As List
            listOfValues.Initialize
            sb.Append("INSERT INTO " & TableName & " (")
            Dim m As Map
            m = ListOfMaps.Get(i1)
            For i2 = 0 To m.Size - 1
                Dim col As String
                Dim value As Object
                col = m.GetKeyAt(i2)
                value = m.GetValueAt(i2)
                If i2 > 0 Then
                    columns.Append(", ")
                    values.Append(", ")
                End If
                columns.Append(col)
                values.Append("?")
                listOfValues.Add(value)
            Next
            sb.Append(columns.ToString)
            sb.Append(") VALUES (")
            sb.Append(values.ToString)
            sb.Append(")")
            If i1 = 0 Then Log("InsertMaps (first query out of " & ListOfMaps.Size & "): " & sb.ToString)
            Log("InsertMaps: " & sb.ToString)
            SQL.ExecNonQuery2(sb.ToString, listOfValues)
        Next
        SQL.TransactionSuccessful
        If UsePool Then
            res = SQLSelectSingleResult(SQL, "SELECT LAST_INSERT_ID()",Null)
        Else
            res = SQLSelectSingleResult(SQL, "SELECT last_insert_rowid()",Null)
        End If
        Return res
    Catch
        Log("InsertMaps Error: " & LastException)
        SQL.Rollback
        Return DBERROR
    End Try
End Sub
'Get a connection to SQL server
Public Sub SQLGet() As SQL
    If DatabaseType = 0 Then
        Return SQLite
    Else
        Return pool.GetConnection
    End If
End Sub
'Close the database connection
Public Sub SQLClose(mySQL As SQL)
    If DatabaseType <> 0 Then
        mySQL.Close
    End If
End Sub
'Determines if a record exists and returns true
Public Sub SQLRecordExists(SQL As SQL, TableName As String, PrimField As String, PrimValue As String) As Boolean
    Dim mr As Map = SQLExecuteMap(SQL, "SELECT " & PrimField & " From " & TableName & " WHERE " & PrimField & " = ?", Array As String(PrimValue))
    If mr.IsInitialized = False Then
        Return False
    Else
        Return True
    End If
End Sub
'Execute a select query and returns a single record
Public Sub SQLExecuteMap(SQL As SQL, Query As String, StringArgs() As String) As Map
    Dim res As Map
    Dim cur As ResultSet
    If StringArgs <> Null Then
        cur = SQL.ExecQuery2(Query, StringArgs)
    Else
        cur = SQL.ExecQuery(Query)
    End If
    Log("ExecuteMap: " & Query)
    If cur.NextRow = False Then
        Log("No records found.")
        Return res
    End If
    res.Initialize
    For i = 0 To cur.ColumnCount - 1
        res.Put(cur.GetColumnName(i).ToLowerCase, cur.GetString2(i))
    Next
    cur.Close
    Return res
End Sub
'Execute a query and return a list of Mapped records
Public Sub SQLExecuteMaps(SQL As SQL, Query As String, args As List) As List
    Dim l As List
    l.Initialize
    Dim cur As ResultSet
    Try
        cur = SQL.ExecQuery2(Query, args)
    Catch
        Log(LastException)
        Return l
    End Try
    Do While cur.NextRow
        Dim res As Map
        res.Initialize
        For i = 0 To cur.ColumnCount - 1
            res.Put(cur.GetColumnName(i).ToLowerCase, cur.GetString2(i))
        Next
        l.Add(res)
    Loop
    cur.Close
    Return l
End Sub
'Read a record from the database and return it as a map
Public Sub SQLRecordRead(SQL As SQL, TableName As String, PrimaryKey As String, PrimaryValue As String) As Map
    Return SQLExecuteMap(SQL, "SELECT * FROM " & TableName & " WHERE " & PrimaryKey & " = ?",Array As String(PrimaryValue))
End Sub
'Delete single/multiple records specifying a primary key
Public Sub SQLRecordDelete(SQL As SQL, TableName As String, KeyField As String, KeyValue As String) As Boolean
    Dim w As Map
    w.Initialize
    w.Put(KeyField,KeyValue)
    Return SQLRecordDeleteWhere(SQL,TableName,w)
End Sub
Public Sub SQLRecordDeleteWhere(SQL As SQL, TableName As String, WhereFieldEquals As Map) As Boolean
    Dim sb As StringBuilder
    sb.Initialize
    sb.Append("DELETE FROM ").Append(TableName).Append(" WHERE ")
    If WhereFieldEquals.Size = 0 Then
        Log("WhereFieldEquals map empty!")
        Return False
    End If
    Dim args As List
    args.Initialize
    For i = 0 To WhereFieldEquals.Size - 1
        If i > 0 Then sb.Append(" AND ")
        sb.Append(WhereFieldEquals.GetKeyAt(i)).Append(" = ?")
        args.Add(WhereFieldEquals.GetValueAt(i))
    Next
    Log("DeleteRecord: " & sb.ToString)
    SQL.BeginTransaction
    Try
        SQL.ExecNonQuery2(sb.ToString, args)
        SQL.TransactionSuccessful
        Return True
    Catch
        SQL.Rollback
        Return False
    End Try
End Sub
Public Sub SQLSelectSingleResult(SQL As SQL, Query As String, Args As List) As String
    Dim res As String
    Try
        res = SQL.ExecQuerySingleResult2(Query, Args)
    Catch
        Log(LastException)
        res = DBERROR
    End Try
    If res = Null Then
        res = DBNORESULTS
    End If
    Return res
End Sub
Public Sub BuildSideBarComponent(page As ABMPage, id As String, image As String, Title As String, Subtitle As String, IsCircular As Boolean) As ABMContainer
    Dim ItemCont As ABMContainer
    ItemCont.Initialize(page, id, "")
    ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,3,3,3,4,0,0,0,"").AddCellsOSMP(1,0,0,0,9,9,9,4,0,0,0,"")
    ItemCont.AddRowsM(1,False,0,0, "").AddCells12(1, "")
    ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    Dim SubItemCont As ABMContainer
    SubItemCont.Initialize(page, id & "SubItemCont", "")
    SubItemCont.AddRowsM(1,False, 0,0,"").AddCells12MP(1,-6,0,0,0,"").AddCells12(1,"")
    SubItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    ItemCont.Cell(1,2).AddComponent(SubItemCont)
    Dim img As ABMImage
    img.Initialize(page, id & "img", image, 1)
    img.SetFixedSize(48,48)
    img.IsCircular = IsCircular
    img.IsResponsive = True
    ItemCont.Cell(1,1).AddComponent(img)
    Dim lbl1 As ABMLabel
    lbl1.Initialize(page, id & "lbl1", Title, ABM.SIZE_H6, False, "lightblue")
    lbl1.VerticalAlign = True
    SubItemCont.Cell(1,1).AddComponent(lbl1)
    Dim lbl2 As ABMLabel
    lbl2.Initialize(page, id & "lbl2", Subtitle, ABM.SIZE_H6, False, "")
    lbl2.VerticalAlign = True
    SubItemCont.Cell(1,2).AddComponent(lbl2)
    Return ItemCont
End Sub
Public Sub BuildSideBarTopComponent(page As ABMPage, id As String, image As String, Title As String, Subtitle As String, IsCircular As Boolean) As ABMContainer
    ' important!
    'page.NeedsChart = true
    Dim ItemCont As ABMContainer
    ItemCont.Initialize(page, id, "")
    ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,3,3,3,4,0,0,0,"").AddCellsOSMP(1,0,0,0,9,9,9,4,0,0,0,"")
    ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,12,12,12,0,0,0,0,"")
    ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    Dim SubItemCont As ABMContainer
    SubItemCont.Initialize(page, id & "SubItemCont", "")
    SubItemCont.AddRowsM(1,False, 0,0,"").AddCells12MP(1,-6,0,0,0,"").AddCells12(1,"")
    SubItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    ItemCont.Cell(1,2).AddComponent(SubItemCont)
    Dim img As ABMImage
    img.Initialize(page, id & "img", image, 1)
    img.SetFixedSize(48,48)
    img.IsCircular = IsCircular
    img.IsResponsive = True
    ItemCont.Cell(1,1).AddComponent(img)
    Dim lbl1 As ABMLabel
    lbl1.Initialize(page, id & "lbl1", Title, ABM.SIZE_H6, False, "whitefc")
    lbl1.VerticalAlign = True
    SubItemCont.Cell(1,1).AddComponent(lbl1)
    Dim lbl2 As ABMLabel
    lbl2.Initialize(page, id & "lbl2", Subtitle, ABM.SIZE_H6, False, "whitefc")
    lbl2.VerticalAlign = True
    SubItemCont.Cell(1,2).AddComponent(lbl2)
    Return ItemCont
End Sub
Public Sub BuildFiche(page As ABMPage, id As String, Title As String, SubTitle As String, Body As String, pic As String, picCaption as string, themeName As String) As ABMContainer
    Dim Fiche As ABMContainer
    Fiche.Initialize(page, "fiche" & id, "")
    Fiche.AddRowsM(1, False,0,0, themeName).AddCellsOSMP(1,0,0,0,12,12,12,0,12,10,10,"")
    Fiche.AddRowsM(1, True,0,0, "").AddCellsOSMP(1,0,0,0,12,12,12,0,0,0,0,"")
    Fiche.BuildGrid
    Fiche.Row(1).MarginLeft = "0"
    Fiche.Row(1).MarginRight = "0"
    Dim titLabel As ABMLabel
    titLabel.Initialize(page, "titlabel" & id, Title, ABM.SIZE_H5,False, "white")
    Fiche.Cell(1,1).AddComponent(titLabel)
    Dim titLabel2 As ABMLabel
    titLabel2.Initialize(page, "titlabel2_" & id, SubTitle, ABM.SIZE_H6,False, "white")
    Fiche.Cell(1,1).AddComponent(titLabel2)
    If pic <> "" Then
        Fiche.Cell(2,1).AddComponent(BuildImage(page, "ficheimg" & id, pic,1, picCaption))
    End If
    Dim lbody As ABMLabel
    lbody.Initialize(page, "body" & id, Body, ABM.SIZE_PARAGRAPH, True, "")
    Fiche.Cell(2,1).AddComponent(lbody)
    Return Fiche
End Sub
Public Sub BuildMsgBox(page As ABMPage) As ABMModalSheet
    Dim msgbox As ABMModalSheet
    msgbox.Initialize(page, "msgbox", False, False, "")
    msgbox.IsDismissible = False
    msgbox.Header.AddRowsM(1, True, 0, 0, "").AddCellsOS(1, 0, 0, 0, 12, 12, 12, "")
    msgbox.Header.BuildGrid
    msgbox.Content.AddRowsM(1, True,0,0, "").AddCells12(1, "")
    msgbox.Content.BuildGrid
    ' add paragraph
    msgbox.Content.CellR(0,1).AddComponent(BuildParagraph(page,"par1","message") )
    msgbox.Footer.AddRowsM(1,True,0,0, "").AddCellsOS(1,0,0,0,12,12,12,"")
    msgbox.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    Dim lblHeader As ABMLabel
    lblHeader.Initialize(page, "lblHeader", "{NBSP}Inform", ABM.SIZE_H5, False, "whitefc")
    msgbox.Header.Cell(1,1).AddComponent(lblHeader)
    ' create the buttons for the footer
    Dim msgok As ABMButton
    msgok.InitializeFlat(page, "msgok", "", "", "CLOSE", "transparent")
    msgbox.Footer.Cell(1,1).AddComponent(msgok)
    Return msgbox
End Sub
Public Sub BuildMsgBoxYesNo(page As ABMPage) As ABMModalSheet
    Dim msg As ABMModalSheet
    msg.Initialize(page, "confirm", False, False, "")
    msg.IsDismissible = False
    msg.Header.AddRowsM(1, True, 0, 0, "").AddCellsOS(1, 0, 0, 0, 12, 12, 12, "")
    msg.Header.BuildGrid
    msg.Content.AddRowsM(1, True,0,0, "").AddCells12(1, "")
    msg.Content.BuildGrid
    ' add paragraph
    msg.Content.CellR(0,1).AddComponent(BuildParagraph(page,"par1","Are you sure you want to delete this user?") )
    msg.Footer.AddRowsM(1,True,0,0, "").AddCellsOS(1,0,0,0,12,12,12,"")
    msg.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    ' create the buttons for the footer
    Dim msgyes As ABMButton
    msgyes.InitializeFlat(page, "msgyes", "", "", "YES", "transparent")
    msg.Footer.Cell(1,1).AddComponent(msgyes)
    Dim msgno As ABMButton
    msgno.InitializeFlat(page, "msgno", "", "", "NO", "transparent")
    msg.Footer.Cell(1,1).AddComponent(msgno)
    Dim lblHeader As ABMLabel
    lblHeader.Initialize(page, "lblHeader", "{NBSP}Confirm", ABM.SIZE_H5, False, "whitefc")
    msg.Header.Cell(1,1).AddComponent(lblHeader)
    Return msg
End Sub
Public Sub BuildWrongInputModalSheet(page As ABMPage) As ABMModalSheet
    Dim myModalError As ABMModalSheet
    myModalError.Initialize(page, "wronginput", False, False, "")
    myModalError.Content.UseTheme("modalcontent")
    myModalError.Footer.UseTheme("modalcontent")
    myModalError.Header.UseTheme("modalcontent")
    myModalError.IsDismissible = True
    ' create the grid for the content
    myModalError.Content.AddRows(1,True, "").AddCells12(1,"")
    myModalError.Content.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    myModalError.Header.AddRowsM(1, True, 0, 0, "").AddCellsOS(1, 0, 0, 0, 12, 12, 12, "")
    myModalError.Header.BuildGrid
    Dim lbl1 As ABMLabel
    lbl1.Initialize(page, "errormsg", "The login or password are incorrect!",ABM.SIZE_PARAGRAPH, False, "")
    myModalError.Content.Cell(1,1).AddComponent(lbl1)
    Dim lblHeader As ABMLabel
    lblHeader.Initialize(page, "lblHeader", "{NBSP}Input", ABM.SIZE_H5, False, "whitefc")
    myModalError.Header.Cell(1,1).AddComponent(lblHeader)
    Return myModalError
End Sub
Public Sub ShowMsgBox(page As ABMPage, strMessage As String)
    Dim msgbox As ABMModalSheet = page.ModalSheet("msgbox")
    Dim lbl As ABMLabel = msgbox.Content.Component("par1")
    lbl.Text = strMessage
    page.ShowModalSheet("msgbox")
End Sub
Public Sub ShowYesNo(page As ABMPage, strMessage As String, strYes As String, strNo As String)
    Dim msg As ABMModalSheet = page.ModalSheet("confirm")
    Dim lbl As ABMLabel = msg.Content.Component("par1")
    Dim msgyes As ABMButton = msg.Footer.Component("msgyes")
    Dim msgno As ABMButton = msg.Footer.Component("msgno")
    lbl.Text = strMessage & "?"
    msgyes.Tag = strYes
    msgno.Tag = strNo
    page.ShowModalSheet("confirm")
End Sub
Public Sub ShowInputError(page As ABMPage, strMessage As String)
    Dim mymodalError As ABMModalSheet = page.ModalSheet("wronginput")
    Dim myModalLbl As ABMLabel= mymodalError.Content.Component("errormsg")
    myModalLbl.Text = strMessage
    page.ShowModalsheet("wronginput")
End Sub
Public Sub KpiFinder(value As String) As String
    value = Round(value)
    value = Abs(value)
    If value <= 5 Then Return "../images/green.png"
    If (value > 5) And (value <= 10) Then Return "../images/amber.png"
    Return "../images/red.png"
End Sub
Public Sub IsZero(current As String,budget As String, actual As String) As String
    If budget = "0" Or actual = "0" Then
        Return "0"
    Else
        Return Round(current)
    End If
End Sub
'compute the values for IYMAnalysisSet
Public Sub IYMAnalysisSet_Compute(m As Map) As Map
    'assign value map to temporal map
    Dim rm As Map
    rm.Initialize
    for Each strKey As String In m.Keys
        Dim strValue As String = m.Get(strKey)
        rm.Put(strKey,strValue)
    Next
    'enter your code here.
    Dim aprchange As String = val(m.getdefault("aprchange","0"))
    Dim maychange As String = val(m.getdefault("maychange","0"))
    Dim junchange As String = Val(m.getdefault("junchange","0"))
    Dim julchange As String = Val(m.getdefault("julchange","0"))
    Dim augchange As String = Val(m.getdefault("augchange","0"))
    Dim sepchange As String = Val(m.getdefault("sepchange","0"))
    Dim octchange As String = Val(m.getdefault("octchange","0"))
    Dim novchange As String = Val(m.getdefault("novchange","0"))
    Dim decchange As String = Val(m.getdefault("decchange","0"))
    Dim janchange As String = Val(m.getdefault("janchange","0"))
    Dim febchange As String = Val(m.getdefault("febchange","0"))
    Dim marchange As String = Val(m.getdefault("marchange","0"))
    Dim varchange As String = Val(m.getdefault("varchange","0"))
    Dim apraccchange As String = Val(m.getdefault("apraccchange","0"))
    Dim mayaccchange As String = Val(m.getdefault("mayaccchange","0"))
    Dim junaccchange As String = Val(m.getdefault("junaccchange","0"))
    Dim julaccchange As String = Val(m.getdefault("julaccchange","0"))
    Dim augaccchange As String = Val(m.getdefault("augaccchange","0"))
    Dim sepaccchange As String = Val(m.getdefault("sepaccchange","0"))
    Dim octaccchange As String = Val(m.getdefault("octaccchange","0"))
    Dim novaccchange As String = Val(m.getdefault("novaccchange","0"))
    Dim decaccchange As String = Val(m.getdefault("decaccchange","0"))
    Dim janaccchange As String = Val(m.getdefault("janaccchange","0"))
    Dim febaccchange As String = Val(m.getdefault("febaccchange","0"))
    Dim maraccchange As String = Val(m.getdefault("maraccchange","0"))
    Dim varaccchange As String = Val(m.getdefault("varaccchange","0"))
    Dim aprkpi As String = KpiFinder(aprchange)
    Dim maykpi As String = KpiFinder(maychange)
    Dim junkpi As String = KpiFinder(junchange)
    Dim julkpi As String = KpiFinder(julchange)
    Dim augkpi As String = KpiFinder(augchange)
    Dim sepkpi As String = KpiFinder(sepchange)
    Dim octkpi As String = KpiFinder(octchange)
    Dim novkpi As String = KpiFinder(novchange)
    Dim deckpi As String = KpiFinder(decchange)
    Dim jankpi As String = KpiFinder(janchange)
    Dim febkpi As String = KpiFinder(febchange)
    Dim markpi As String = KpiFinder(marchange)
    Dim varkpi As String = KpiFinder(varchange)
    'update % expenditure
    rm.put("aprkpi", aprkpi)
    rm.put("maykpi", maykpi)
    rm.put("junkpi", junkpi)
    rm.put("julkpi", julkpi)
    rm.put("augkpi", augkpi)
    rm.put("sepkpi", sepkpi)
    rm.put("octkpi", octkpi)
    rm.put("novkpi", novkpi)
    rm.put("deckpi", deckpi)
    rm.put("jankpi", jankpi)
    rm.put("febkpi", febkpi)
    rm.put("markpi", markpi)
    rm.put("varkpi", varkpi)
    Dim apracckpi As String = KpiFinder(apraccchange)
    Dim mayacckpi As String = KpiFinder(mayaccchange)
    Dim junacckpi As String = KpiFinder(junaccchange)
    Dim julacckpi As String = KpiFinder(julaccchange)
    Dim augacckpi As String = KpiFinder(augaccchange)
    Dim sepacckpi As String = KpiFinder(sepaccchange)
    Dim octacckpi As String = KpiFinder(octaccchange)
    Dim novacckpi As String = KpiFinder(novaccchange)
    Dim decacckpi As String = KpiFinder(decaccchange)
    Dim janacckpi As String = KpiFinder(janaccchange)
    Dim febacckpi As String = KpiFinder(febaccchange)
    Dim maracckpi As String = KpiFinder(maraccchange)
    'update % expenditure
    rm.put("apracckpi", apracckpi)
    rm.put("mayacckpi", mayacckpi)
    rm.put("junacckpi", junacckpi)
    rm.put("julacckpi", julacckpi)
    rm.put("augacckpi", augacckpi)
    rm.put("sepacckpi", sepacckpi)
    rm.put("octacckpi", octacckpi)
    rm.put("novacckpi", novacckpi)
    rm.put("decacckpi", decacckpi)
    rm.put("janacckpi", janacckpi)
    rm.put("febacckpi", febacckpi)
    rm.put("maracckpi", maracckpi)
    Return rm
End Sub
'Sum method for IYMAnalysisSet
Public Sub IYMAnalysisSet_Sum(page As ABMPage)
    'Define the variables to hold the summing values of the table
    Dim cAprProj As String = "0"
    Dim cMayProj As String = "0"
    Dim cJunProj As String = "0"
    Dim cJulProj As String = "0"
    Dim cAugProj As String = "0"
    Dim cSepProj As String = "0"
    Dim cOctProj As String = "0"
    Dim cNovProj As String = "0"
    Dim cDecProj As String = "0"
    Dim cJanProj As String = "0"
    Dim cFebProj As String = "0"
    Dim cMarProj As String = "0"
    Dim cAprAct As String = "0"
    Dim cMayAct As String = "0"
    Dim cJunAct As String = "0"
    Dim cJulAct As String = "0"
    Dim cAugAct As String = "0"
    Dim cSepAct As String = "0"
    Dim cOctAct As String = "0"
    Dim cNovAct As String = "0"
    Dim cDecAct As String = "0"
    Dim cJanAct As String = "0"
    Dim cFebAct As String = "0"
    Dim cMarAct As String = "0"
    'Define the variables to hold the grouping columns
    Dim gYear As String = ""
    'Define the record map holder
    Dim results As List
    Dim resCnt As Int
    Dim resTot As Int
    Dim resMap As Map
    Dim qry As String = "select Year,sum(AprProj) As AprProj,sum(MayProj) As MayProj,sum(JunProj) As JunProj,sum(JulProj) As JulProj,sum(AugProj) As AugProj,sum(SepProj) As SepProj,sum(OctProj) As OctProj,sum(NovProj) As NovProj,sum(DecProj) As DecProj,sum(JanProj) As JanProj,sum(FebProj) As FebProj,sum(MarProj) As MarProj,sum(AprAct) As AprAct,sum(MayAct) As MayAct,sum(JunAct) As JunAct,sum(JulAct) As JulAct,sum(AugAct) As AugAct,sum(SepAct) As SepAct,sum(OctAct) As OctAct,sum(NovAct) As NovAct,sum(DecAct) As DecAct,sum(JanAct) As JanAct,sum(FebAct) As FebAct,sum(MarAct) As MarAct from IYMAnalysisSet where issum = 0 group by Year"
    page.Pause
    'Get connection from current pool if MySQL/MSSQL
    Dim SQL As SQL = SQLGet
    'we have update statements, process them first.
    Dim sqlCommands As List
    sqlCommands.Initialize
    sqlCommands.add("﻿update iymanalysisset set aprvar = aprproj - apract")
    sqlCommands.add("update iymanalysisset set mayvar = mayproj - mayact")
    sqlCommands.add("update iymanalysisset set junvar = junproj - junact")
    sqlCommands.add("update iymanalysisset set julvar = julproj - julact")
    sqlCommands.add("update iymanalysisset set augvar = augproj - augact")
    sqlCommands.add("update iymanalysisset set sepvar = sepproj - sepact")
    sqlCommands.add("update iymanalysisset set octvar = octproj - octact")
    sqlCommands.add("update iymanalysisset set novvar = novproj - novact")
    sqlCommands.add("update iymanalysisset set decvar = decproj - decact")
    sqlCommands.add("update iymanalysisset set janvar = janproj - janact")
    sqlCommands.add("update iymanalysisset set febvar = febproj - febact")
    sqlCommands.add("update iymanalysisset set marvar = marproj - maract")
    sqlCommands.add("update iymanalysisset set projections = aprproj + mayproj + junproj + julproj + augproj + sepproj + octproj + novproj + decproj + janproj + febproj + marproj")
    sqlCommands.add("update iymanalysisset set actual = apract + mayact + junact + julact + augact + sepact + octact + novact + decact + janact + febact + maract")
    sqlCommands.add("update iymanalysisset set variance = aprvar + mayvar + junvar + julvar + augvar + sepvar + octvar + novvar + decvar + janvar + febvar + marvar")
    sqlCommands.add("update iymanalysisset set apracc = apract")
    sqlCommands.add("update iymanalysisset set mayacc = apracc + mayact")
    sqlCommands.add("update iymanalysisset set junacc = mayacc + junact")
    sqlCommands.add("update iymanalysisset set julacc = junacc + julact")
    sqlCommands.add("update iymanalysisset set augacc = julacc + augact")
    sqlCommands.add("update iymanalysisset set sepacc = augacc + sepact")
    sqlCommands.add("update iymanalysisset set octacc = sepacc + octact")
    sqlCommands.add("update iymanalysisset set novacc = octacc + novact")
    sqlCommands.add("update iymanalysisset set decacc = novacc + decact")
    sqlCommands.add("update iymanalysisset set janacc = decacc + janact")
    sqlCommands.add("update iymanalysisset set febacc = janacc + febact")
    sqlCommands.add("update iymanalysisset set maracc = febacc + maract")
    sqlCommands.add("update iymanalysisset set aprprojacc = aprproj")
    sqlCommands.add("update iymanalysisset set mayprojacc = aprprojacc + mayproj")
    sqlCommands.add("update iymanalysisset set junprojacc = mayprojacc + junproj")
    sqlCommands.add("update iymanalysisset set julprojacc = junprojacc + julproj")
    sqlCommands.add("update iymanalysisset set augprojacc = julprojacc + augproj")
    sqlCommands.add("update iymanalysisset set sepprojacc = augprojacc + sepproj")
    sqlCommands.add("update iymanalysisset set octprojacc = sepprojacc + octproj")
    sqlCommands.add("update iymanalysisset set novprojacc = octprojacc + novproj")
    sqlCommands.add("update iymanalysisset set decprojacc = novprojacc + decproj")
    sqlCommands.add("update iymanalysisset set janprojacc = decprojacc + janproj")
    sqlCommands.add("update iymanalysisset set febprojacc = janprojacc + febproj")
    sqlCommands.add("update iymanalysisset set marprojacc = febprojacc + marproj")
    sqlCommands.add("update iymanalysisset set aprperc = round((apract / aprproj)*100)")
    sqlCommands.add("update iymanalysisset set mayperc = round((mayact / mayproj)*100)")
    sqlCommands.add("update iymanalysisset set junperc = round((junact / junproj)*100)")
    sqlCommands.add("update iymanalysisset set julperc = round((julact / julproj)*100)")
    sqlCommands.add("update iymanalysisset set augperc = round((augact / augproj)*100)")
    sqlCommands.add("update iymanalysisset set sepperc = round((sepact / sepproj)*100)")
    sqlCommands.add("update iymanalysisset set octperc = round((octact / octproj)*100)")
    sqlCommands.add("update iymanalysisset set novperc = round((novact / novproj)*100)")
    sqlCommands.add("update iymanalysisset set decperc = round((decact / decproj)*100)")
    sqlCommands.add("update iymanalysisset set janperc = round((janact / janproj)*100)")
    sqlCommands.add("update iymanalysisset set febperc = round((febact / febproj)*100)")
    sqlCommands.add("update iymanalysisset set marperc = round((maract / marproj)*100)")
    sqlCommands.add("update iymanalysisset set varperc = round((actual / projections)*100)")
    sqlCommands.add("update iymanalysisset set apraccperc = round((apracc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set mayaccperc = round((mayacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set junaccperc = round((junacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set julaccperc = round((julacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set augaccperc = round((augacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set sepaccperc = round((sepacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set octaccperc = round((octacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set novaccperc = round((novacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set decaccperc = round((decacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set janaccperc = round((janacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set febaccperc = round((febacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set maraccperc = round((maracc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set aprprojaccperc = round((aprprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set mayprojaccperc = round((mayprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set junprojaccperc = round((junprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set julprojaccperc = round((julprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set augprojaccperc = round((augprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set sepprojaccperc = round((sepprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set octprojaccperc = round((octprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set novprojaccperc = round((novprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set decprojaccperc = round((decprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set janprojaccperc = round((janprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set febprojaccperc = round((febprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set marprojaccperc = round((marprojacc / adjapp)*100)")
    sqlCommands.add("update iymanalysisset set aprchange = round(((apract - aprproj) / aprproj)*100)")
    sqlCommands.add("update iymanalysisset set maychange = round(((mayact - mayproj) / mayproj)*100)")
    sqlCommands.add("update iymanalysisset set junchange = round(((junact - junproj) / junproj)*100)")
    sqlCommands.add("update iymanalysisset set julchange = round(((julact - julproj) / julproj)*100)")
    sqlCommands.add("update iymanalysisset set augchange = round(((augact - augproj) / augproj)*100)")
    sqlCommands.add("update iymanalysisset set sepchange = round(((sepact - sepproj) / sepproj)*100)")
    sqlCommands.add("update iymanalysisset set octchange = round(((octact - octproj) / octproj)*100)")
    sqlCommands.add("update iymanalysisset set novchange = round(((novact - novproj) / novproj)*100)")
    sqlCommands.add("update iymanalysisset set decchange = round(((decact - decproj) / decproj)*100)")
    sqlCommands.add("update iymanalysisset set janchange = round(((janact - janproj) / janproj)*100)")
    sqlCommands.add("update iymanalysisset set febchange = round(((febact - febproj) / febproj)*100)")
    sqlCommands.add("update iymanalysisset set marchange = round(((maract - marproj) / marproj)*100)")
    sqlCommands.add("update iymanalysisset set varchange = round(((actual - projections) / projections)*100)")
    sqlCommands.add("update iymanalysisset set apraccchange = round(((apracc - aprprojacc) / aprprojacc)*100)")
    sqlCommands.add("update iymanalysisset set mayaccchange = round(((mayacc - mayprojacc) / mayprojacc)*100)")
    sqlCommands.add("update iymanalysisset set junaccchange = round(((junacc - junprojacc) / junprojacc)*100)")
    sqlCommands.add("update iymanalysisset set julaccchange = round(((julacc - julprojacc) / julprojacc)*100)")
    sqlCommands.add("update iymanalysisset set augaccchange = round(((augacc - augprojacc) / augprojacc)*100)")
    sqlCommands.add("update iymanalysisset set sepaccchange = round(((sepacc - sepprojacc) / sepprojacc)*100)")
    sqlCommands.add("update iymanalysisset set octaccchange = round(((octacc - octprojacc) / octprojacc)*100)")
    sqlCommands.add("update iymanalysisset set novaccchange = round(((novacc - novprojacc) / novprojacc)*100)")
    sqlCommands.add("update iymanalysisset set decaccchange = round(((decacc - decprojacc) / decprojacc)*100)")
    sqlCommands.add("update iymanalysisset set janaccchange = round(((janacc - janprojacc) / janprojacc)*100)")
    sqlCommands.add("update iymanalysisset set febaccchange = round(((febacc - febprojacc) / febprojacc)*100)")
    sqlCommands.add("update iymanalysisset set maraccchange = round(((maracc - marprojacc) / marprojacc)*100)")
    sqlCommands.add("update iymanalysisset set apraccvar = aprprojacc - apracc")
    sqlCommands.add("update iymanalysisset set mayaccvar = mayprojacc - mayacc")
    sqlCommands.add("update iymanalysisset set junaccvar = junprojacc - junacc")
    sqlCommands.add("update iymanalysisset set julaccvar = julprojacc - julacc")
    sqlCommands.add("update iymanalysisset set augaccvar = augprojacc - augacc")
    sqlCommands.add("update iymanalysisset set sepaccvar = sepprojacc - sepacc")
    sqlCommands.add("update iymanalysisset set octaccvar = octprojacc - octacc")
    sqlCommands.add("update iymanalysisset set novaccvar = novprojacc - novacc")
    sqlCommands.add("update iymanalysisset set decaccvar = decprojacc - decacc")
    sqlCommands.add("update iymanalysisset set janaccvar = janprojacc - janacc")
    sqlCommands.add("update iymanalysisset set febaccvar = febprojacc - febacc")
    sqlCommands.add("update iymanalysisset set maraccvar = marprojacc - maracc")
    sqlCommands.add("update iymanalysisset set aprimg = '../images/up.png' where aprvar < 0")
    sqlCommands.add("update iymanalysisset set aprimg = '../images/down.png' where aprvar > 0")
    sqlCommands.add("update iymanalysisset set aprimg = '../images/same.png' where aprvar = 0")
    sqlCommands.add("update iymanalysisset set mayimg = '../images/up.png' where mayvar < 0")
    sqlCommands.add("update iymanalysisset set mayimg = '../images/down.png' where mayvar > 0")
    sqlCommands.add("update iymanalysisset set mayimg = '../images/same.png' where mayvar = 0")
    sqlCommands.add("update iymanalysisset set junimg = '../images/up.png' where junvar < 0")
    sqlCommands.add("update iymanalysisset set junimg = '../images/down.png' where junvar > 0")
    sqlCommands.add("update iymanalysisset set junimg = '../images/same.png' where junvar = 0")
    sqlCommands.add("update iymanalysisset set julimg = '../images/up.png' where julvar < 0")
    sqlCommands.add("update iymanalysisset set julimg = '../images/down.png' where julvar > 0")
    sqlCommands.add("update iymanalysisset set julimg = '../images/same.png' where julvar = 0")
    sqlCommands.add("update iymanalysisset set augimg = '../images/up.png' where augvar < 0")
    sqlCommands.add("update iymanalysisset set augimg = '../images/down.png' where augvar > 0")
    sqlCommands.add("update iymanalysisset set augimg = '../images/same.png' where augvar = 0")
    sqlCommands.add("update iymanalysisset set sepimg = '../images/up.png' where sepvar < 0")
    sqlCommands.add("update iymanalysisset set sepimg = '../images/down.png' where sepvar > 0")
    sqlCommands.add("update iymanalysisset set sepimg = '../images/same.png' where sepvar = 0")
    sqlCommands.add("update iymanalysisset set octimg = '../images/up.png' where octvar < 0")
    sqlCommands.add("update iymanalysisset set octimg = '../images/down.png' where octvar > 0")
    sqlCommands.add("update iymanalysisset set octimg = '../images/same.png' where octvar = 0")
    sqlCommands.add("update iymanalysisset set novimg = '../images/up.png' where novvar < 0")
    sqlCommands.add("update iymanalysisset set novimg = '../images/down.png' where novvar > 0")
    sqlCommands.add("update iymanalysisset set novimg = '../images/same.png' where novvar = 0")
    sqlCommands.add("update iymanalysisset set decimg = '../images/up.png' where decvar < 0")
    sqlCommands.add("update iymanalysisset set decimg = '../images/down.png' where decvar > 0")
    sqlCommands.add("update iymanalysisset set decimg = '../images/same.png' where decvar = 0")
    sqlCommands.add("update iymanalysisset set janimg = '../images/up.png' where janvar < 0")
    sqlCommands.add("update iymanalysisset set janimg = '../images/down.png' where janvar > 0")
    sqlCommands.add("update iymanalysisset set janimg = '../images/same.png' where janvar = 0")
    sqlCommands.add("update iymanalysisset set febimg = '../images/up.png' where febvar < 0")
    sqlCommands.add("update iymanalysisset set febimg = '../images/down.png' where febvar > 0")
    sqlCommands.add("update iymanalysisset set febimg = '../images/same.png' where febvar = 0")
    sqlCommands.add("update iymanalysisset set marimg = '../images/up.png' where marvar < 0")
    sqlCommands.add("update iymanalysisset set marimg = '../images/down.png' where marvar > 0")
    sqlCommands.add("update iymanalysisset set marimg = '../images/same.png' where marvar = 0")
    sqlCommands.add("update iymanalysisset set varimg = '../images/up.png' where [variance] < 0")
    sqlCommands.add("update iymanalysisset set varimg = '../images/down.png' where [variance] > 0")
    sqlCommands.add("update iymanalysisset set varimg = '../images/same.png' where [variance] = 0")
    sqlCommands.add("update iymanalysisset set apraccimg = '../images/up.png' where apraccvar < 0")
    sqlCommands.add("update iymanalysisset set apraccimg = '../images/down.png' where apraccvar > 0")
    sqlCommands.add("update iymanalysisset set apraccimg = '../images/same.png' where apraccvar = 0")
    sqlCommands.add("update iymanalysisset set mayaccimg = '../images/up.png' where mayaccvar < 0")
    sqlCommands.add("update iymanalysisset set mayaccimg = '../images/down.png' where mayaccvar > 0")
    sqlCommands.add("update iymanalysisset set mayaccimg = '../images/same.png' where mayaccvar = 0")
    sqlCommands.add("update iymanalysisset set junaccimg = '../images/up.png' where junaccvar < 0")
    sqlCommands.add("update iymanalysisset set junaccimg = '../images/down.png' where junaccvar > 0")
    sqlCommands.add("update iymanalysisset set junaccimg = '../images/same.png' where junaccvar = 0")
    sqlCommands.add("update iymanalysisset set julaccimg = '../images/up.png' where julaccvar < 0")
    sqlCommands.add("update iymanalysisset set julaccimg = '../images/down.png' where julaccvar > 0")
    sqlCommands.add("update iymanalysisset set julaccimg = '../images/same.png' where julaccvar = 0")
    sqlCommands.add("update iymanalysisset set augaccimg = '../images/up.png' where augaccvar < 0")
    sqlCommands.add("update iymanalysisset set augaccimg = '../images/down.png' where augaccvar > 0")
    sqlCommands.add("update iymanalysisset set augaccimg = '../images/same.png' where augaccvar = 0")
    sqlCommands.add("update iymanalysisset set sepaccimg = '../images/up.png' where sepaccvar < 0")
    sqlCommands.add("update iymanalysisset set sepaccimg = '../images/down.png' where sepaccvar > 0")
    sqlCommands.add("update iymanalysisset set sepaccimg = '../images/same.png' where sepaccvar = 0")
    sqlCommands.add("update iymanalysisset set octaccimg = '../images/up.png' where octaccvar < 0")
    sqlCommands.add("update iymanalysisset set octaccimg = '../images/down.png' where octaccvar > 0")
    sqlCommands.add("update iymanalysisset set octaccimg = '../images/same.png' where octaccvar = 0")
    sqlCommands.add("update iymanalysisset set novaccimg = '../images/up.png' where novaccvar < 0")
    sqlCommands.add("update iymanalysisset set novaccimg = '../images/down.png' where novaccvar > 0")
    sqlCommands.add("update iymanalysisset set novaccimg = '../images/same.png' where novaccvar = 0")
    sqlCommands.add("update iymanalysisset set decaccimg = '../images/up.png' where decaccvar < 0")
    sqlCommands.add("update iymanalysisset set decaccimg = '../images/down.png' where decaccvar > 0")
    sqlCommands.add("update iymanalysisset set decaccimg = '../images/same.png' where decaccvar = 0")
    sqlCommands.add("update iymanalysisset set janaccimg = '../images/up.png' where janaccvar < 0")
    sqlCommands.add("update iymanalysisset set janaccimg = '../images/down.png' where janaccvar > 0")
    sqlCommands.add("update iymanalysisset set janaccimg = '../images/same.png' where janaccvar = 0")
    sqlCommands.add("update iymanalysisset set febaccimg = '../images/up.png' where febaccvar < 0")
    sqlCommands.add("update iymanalysisset set febaccimg = '../images/down.png' where febaccvar > 0")
    sqlCommands.add("update iymanalysisset set febaccimg = '../images/same.png' where febaccvar = 0")
    sqlCommands.add("update iymanalysisset set maraccimg = '../images/up.png' where maraccvar < 0")
    sqlCommands.add("update iymanalysisset set maraccimg = '../images/down.png' where maraccvar > 0")
    sqlCommands.add("update iymanalysisset set maraccimg = '../images/same.png' where maraccvar = 0")
    SQL.BeginTransaction
    Try
        For Each sqlCommand As String In sqlCommands
            SQL.ExecNonQuery(sqlCommand)
        Next
        SQL.TransactionSuccessful
    Catch
        SQL.Rollback
    End Try
    'Get the records as a list of maps from the db
    results = SQLExecuteMaps(SQL, qry, Null)
    'Loop throught each record read and process it
    resTot = results.size - 1
    For resCnt = 0 To resTot
        'Get the record map
        resMap = results.get(resCnt)
        'get each of the values in the summation table
        cAprProj = resMap.GetDefault("aprproj", "0")
        cMayProj = resMap.GetDefault("mayproj", "0")
        cJunProj = resMap.GetDefault("junproj", "0")
        cJulProj = resMap.GetDefault("julproj", "0")
        cAugProj = resMap.GetDefault("augproj", "0")
        cSepProj = resMap.GetDefault("sepproj", "0")
        cOctProj = resMap.GetDefault("octproj", "0")
        cNovProj = resMap.GetDefault("novproj", "0")
        cDecProj = resMap.GetDefault("decproj", "0")
        cJanProj = resMap.GetDefault("janproj", "0")
        cFebProj = resMap.GetDefault("febproj", "0")
        cMarProj = resMap.GetDefault("marproj", "0")
        cAprAct = resMap.GetDefault("apract", "0")
        cMayAct = resMap.GetDefault("mayact", "0")
        cJunAct = resMap.GetDefault("junact", "0")
        cJulAct = resMap.GetDefault("julact", "0")
        cAugAct = resMap.GetDefault("augact", "0")
        cSepAct = resMap.GetDefault("sepact", "0")
        cOctAct = resMap.GetDefault("octact", "0")
        cNovAct = resMap.GetDefault("novact", "0")
        cDecAct = resMap.GetDefault("decact", "0")
        cJanAct = resMap.GetDefault("janact", "0")
        cFebAct = resMap.GetDefault("febact", "0")
        cMarAct = resMap.GetDefault("maract", "0")
        'get the grouping columns
        gYear = resMap.GetDefault("year", "")
        'Update the record in the database...
        'Define the where clause
        Dim WhereMap As Map
        WhereMap.Initialize
        WhereMap.put("year",gYear)
        'The IsSum for the record to update should be 1
        WhereMap.put("issum","1")
        'Define the fields to update
        Dim FldMap As Map
        FldMap.Initialize
        FldMap.put("aprproj", cAprProj)
        FldMap.put("mayproj", cMayProj)
        FldMap.put("junproj", cJunProj)
        FldMap.put("julproj", cJulProj)
        FldMap.put("augproj", cAugProj)
        FldMap.put("sepproj", cSepProj)
        FldMap.put("octproj", cOctProj)
        FldMap.put("novproj", cNovProj)
        FldMap.put("decproj", cDecProj)
        FldMap.put("janproj", cJanProj)
        FldMap.put("febproj", cFebProj)
        FldMap.put("marproj", cMarProj)
        FldMap.put("apract", cAprAct)
        FldMap.put("mayact", cMayAct)
        FldMap.put("junact", cJunAct)
        FldMap.put("julact", cJulAct)
        FldMap.put("augact", cAugAct)
        FldMap.put("sepact", cSepAct)
        FldMap.put("octact", cOctAct)
        FldMap.put("novact", cNovAct)
        FldMap.put("decact", cDecAct)
        FldMap.put("janact", cJanAct)
        FldMap.put("febact", cFebAct)
        FldMap.put("maract", cMarAct)
        FldMap.put("year", gYear)
        'Update the database record
        SQLRecordUpdateWhere(SQL, "IYMAnalysisSet", FldMap, WhereMap)
    Next
    'Close the connection to the database
    SQLClose(SQL)
    page.resume
End Sub
