﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Public Sub Class_Globals
    Private ws As WebSocket 'ignore
    ' will hold our page information
    Public page As ABMPage
    ' page theme
    Private theme As ABMTheme
    ' to access the constants
    Private ABM As ABMaterial 'ignore
    ' name of the page, must be the same as the class name (case sensitive!)
    Public Name As String = "frmCuteFileBrowser"  '<-------------------------------------------------------- IMPORTANT
    Private ABMPageId As String = ""
    ' your own variables
    Dim Origin As String = "http://localhost:51045" '<--- IMPORTANT for youtube videos.  Set here your website address
    ' the download folder
    Public DownloadFolder As String = "/www/" & ABMShared.AppName & "/uploads/"
    Public DownloadMaxSize As String = 100*1024
    Private myToastId As Int
    Private dbAction As Map
    Private ActiveID As Int
    Private IsNew As Boolean
    Private Filter As String
    Private LastSort As String
    Private FilterCount As String
    Private OldValue As String
    Public MaxRows As Int = 10
    Private cfb As CuteFileBrowser
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize()
    ' build the local structure IMPORTANT!
    BuildPage
End Sub
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
    Log("Connected")
    ws = WebSocket1
    ABMPageId = ABM.GetPageID(page, Name,ws)
    Dim session As HttpSession = ABM.GetSession(ws, ABMShared.SessionMaxInactiveIntervalSeconds)
    'page specific authorization
    If session.GetAttribute2("frmCuteFileBrowser", "false") = "true" Then
        If session.GetAttribute2("IsAuthorized", "") = "" Then
            ABMShared.NavigateToPage(ws, ABMPageId, "../")
            Return
        End If
    End If
    If ABMShared.NeedsAuthorization Then
        If session.GetAttribute2("IsAuthorized", "") = "" Then
            ABMShared.NavigateToPage(ws, ABMPageId, "../")
            Return
        End If
    End If
    ABM.UpdateFromCache(Me, ABMShared.CachedPages, ABMPageId, ws)
    If page.ComesFromPageCache Then
        ' refresh the page
        page.Refresh
        ' because we use ShowLoaderType=ABM.LOADER_TYPE_MANUAL
        page.FinishedLoading
    Else
        ' Prepare the page
        page.Prepare
        ' load the dynamic content
        ConnectPage
    End If
    Log(ABMPageId)
End Sub
Private Sub WebSocket_Disconnected()
    Log("Disconnected")
End Sub
Public Sub Page_ParseEvent(Params As Map)
    Dim eventName As String = Params.Get("eventname")
    Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
    If eventName = "beforeunload" Then
        Log("preparing for url refresh")
        ABM.RemoveMeFromCache(ABMShared.CachedPages, ABMPageId)
        Return
    End If
    If SubExists(Me, eventName) Then
        Params.Remove("eventname")
        Params.Remove("eventparams")
        Select Case Params.Size
        Case 0
            CallSub(Me, eventName)
        Case 1
            CallSub2(Me, eventName, Params.Get(eventParams(0)))
        Case 2
            If Params.get(eventParams(0)) = "abmistable" Then
                Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
                CallSub2(Me, eventName, PassedTables)
            Else
                CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
            End If
        Case Else
            ' cannot be called diretly, to many param
            CallSub2(Me, eventName, Params)
        End Select
    End If
End Sub
public Sub BuildTheme()
    ' start with the base theme defined in ABMShared
    theme.Initialize("pagetheme")
    theme.AddABMTheme(ABMShared.MyTheme)
    ' add additional themes specific for this page
    theme.Page.BackColor = ABM.COLOR_TRANSPARENT
    theme.Page.BackColorIntensity = ABM.INTENSITY_NORMAL
    theme.Page.ConnectedIndicatorColor = ABM.COLOR_GREEN
    theme.Page.ConnectedIndicatorColorIntensity = ABM.INTENSITY_NORMAL
    theme.Page.DisconnectedIndicatorColor = ABM.COLOR_RED
    theme.Page.DisconnectedIndicatorColorIntensity = ABM.INTENSITY_NORMAL
    theme.Page.PlaceHolderColor = ABM.COLOR_GREY
    theme.Page.PlaceHolderColorIntensity = ABM.INTENSITY_NORMAL
End Sub
public Sub BuildPage()
    ' initialize the theme
    BuildTheme
    ' initialize this page using our theme
    page.InitializeWithTheme(Name, "/ws/" & ABMShared.AppName & "/" & Name, False, ABMShared.SessionMaxInactiveIntervalSeconds, theme)
    page.ShowLoader=True
    page.ShowLoaderType=ABM.LOADER_TYPE_MANUAL
    page.PageHTMLName = "frmCuteFileBrowser.html"
    page.PageTitle = "DRPW"
    page.PageDescription = ""
    page.PageKeywords = ""
    page.PageSiteMapPriority = "0.50"
    page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_MONTHLY
    'page.UseFontAwesome = False
    page.DisableBackButton = False
    page.UseGoogleAnalytics(ABMShared.TrackingID, Null) ' IMPORTANT Change this to your own TrackingID !!!!!!!
    page.GoogleMapsAPIExtras = ABMShared.GoogleMapsAPIExtras
    page.IsFixedFooter = False
    page.DisablePageReloadOnSwipeDown = True
    page.ShowConnectedIndicator = True
    page.PageLanguage = "en"
    page.SetFontStack("arial,sans-serif")
    page.AlwaysShowVerticalScrollBar = False
    page.AddExtraJavaScriptFile("custom/script.js")
    page.AddExtraCSSFile("custom/styles.css")
    ' adding a navigation bar
    Dim sbtopimg As ABMImage
    sbtopimg.Initialize(page, "sbtopimg", "../images/drpwlogo.png", 1)
    sbtopimg.IsCircular = False
    sbtopimg.SetFixedSize(279, 79)
    page.NavigationBar.Initialize(page, "navBar", ABM.SIDEBAR_MANUAL_ALWAYSHIDE, "Cute File Browser", True, True, 400, 49, sbtopimg, ABM.COLLAPSE_ACCORDION, "drpw")
    page.NavigationBar.SideBarLogoHeight = 79
    page.NavigationBar.TopBarDropDownConstrainWidth = True
    ' you must add at least ONE dummy item if you want to add items to the topbar in ConnectNaviagationBar
    page.NavigationBar.AddTopItem("DUMMY", " ", "", "", False)
    ' you must add at least ONE dummy item if you want to add items to the sidebar
    page.NavigationBar.AddSideBarItem("DUMMY", " ", "", "")
    page.ShowGridInfo = True
    ' create the page grid
    page.AddRows(2, True, "").AddCells12(1, "")
    page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    ' add a error box template if the name is not entered
    page.AddModalSheetTemplate(ABMShared.BuildWrongInputModalSheet(page))
    ' add a modal sheet template for a yes no msgbox
    page.AddModalSheetTemplate(ABMShared.BuildMsgBoxYesNo(page))
    ' add a modal sheet template for a  msgbox
    page.AddModalSheetTemplate(ABMShared.BuildMsgBox(page))
End Sub
Public Sub msgyes_Clicked(Target As String)
    Dim msg As ABMModalSheet = page.ModalSheet("confirm")
    Dim msgyes As ABMButton = msg.Footer.Component("msgyes")
    Dim strTag As String
    strTag = msgyes.Tag
    page.CloseModalSheet("confirm")
End Sub
Public Sub msgok_Clicked(Target As String)
    page.CloseModalSheet("msgbox")
End Sub
Public Sub msgno_Clicked(Target As String)
    page.CloseModalSheet("confirm")
End Sub
' clicked on the navigation bar
Public Sub Page_NavigationbarClicked(Action As String, Value As String)
    page.SaveNavigationBarPosition
    If Action = "LogOff" Then
        ABMShared.LogOff(page)
        Return
    End If
    ABMShared.NavigateToPage(ws, ABMPageId, Value)
End Sub
Public Sub Page_FileUploaded(FileName As String, success As Boolean)
    page.ws.Flush ' IMPORTANT
End Sub
Public Sub Page_ToastClicked(ToastId As String, Action As String)
    page.DismissToast(ToastId)
End Sub
Public Sub Page_ToastDismissed(ToastId As String)
End Sub
Public Sub ConnectPage()
    'connect navigation bar
    ConnectNavigationBar
    Dim NowWH As String = ABM.GetBrowserWidthHeight(page)
    If NowWH <> "" And NowWH <> ";" Then
        Dim split() As String = Regex.Split(";", NowWH)
        Dim NewH As Int = split(1) - 350
        NewH = NewH / 50
        NewH = NewH / 5
        NewH = NewH * 5
        If NewH >= 10 Then
            MaxRows = NewH
        End If
    End If
    'add components for the page
    cfb.Initialize(page, "cfb")
	page.cell(2,1).SetFixedHeightFromBottom(20,False) 
    page.Cell(2,1).AddComponent(cfb.ABMComp)
    AdminAccess
    page.Refresh ' IMPORTANT
    ' NEW, because we use ShowLoaderType=ABM.LOADER_TYPE_MANUAL
    page.FinishedLoading 'IMPORTANT
    page.RestoreNavigationBarPosition
End Sub
Public Sub Page_SignedOffSocialNetwork(Network As String, Extra As String)
    page.ws.Session.SetAttribute("UserID", "")
    page.ws.Session.SetAttribute("UserEmail", "")
    page.ws.Session.SetAttribute("authType", "")
    page.ws.Session.SetAttribute("authName", "")
    page.ws.Session.SetAttribute("IsAuthorized", "")
    ABMShared.NavigateToPage(ws,ABMPageId, "../")
End Sub
Public Sub ExecuteGoBack()
    ABMShared.NavigateToPage(ws, ABMPageId, "../frmIYMMenu/frmIYMMenu.html")
End Sub
'Refresh the contents of an ABMSideBarItem in runtime

Public Sub AdminAccess()
    'Get the usertype
    Dim UserType As String = ws.Session.GetAttribute2("UserType", "0")
End Sub
Public Sub ConnectNavigationBar()
    ' Clear the dummies we created in BuildNavigationBar
    page.NavigationBar.Clear
    'refresh the navigation bar
    page.NavigationBar.Refresh ' IMPORTANT
End Sub
